package com.ruoyi.project.production.controller;

import java.io.IOException;
import java.text.DecimalFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.utils.file.FileUploadUtils;
import com.ruoyi.common.utils.file.FileUtils;
import com.ruoyi.framework.config.RuoYiConfig;
import com.ruoyi.project.common.domain.TCommonfile;
import com.ruoyi.project.common.service.ITCommonfileService;
import com.ruoyi.project.production.controller.vo.FurnancePressureFvpVO;
import com.ruoyi.project.production.controller.vo.FurnancePressureVO;
import com.ruoyi.project.production.controller.vo.FurnanceSummaryVO;
import com.ruoyi.project.production.controller.vo.FvpAnalysisQueryVO;
import com.ruoyi.project.production.domain.TFurnanceTemperature;
import com.ruoyi.project.production.mapper.TFurnancePressureMapper;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import com.ruoyi.framework.aspectj.lang.annotation.Log;
import com.ruoyi.framework.aspectj.lang.enums.BusinessType;
import com.ruoyi.project.production.domain.TFurnancePressure;
import com.ruoyi.project.production.service.ITFurnancePressureService;
import com.ruoyi.framework.web.controller.BaseController;
import com.ruoyi.framework.web.domain.AjaxResult;
import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.framework.web.page.TableDataInfo;
import org.springframework.web.multipart.MultipartFile;


/**
 * 裂解炉炉管测压Controller
 *
 * @author ssy
 * @date 2024-03-21
 */
@RestController
@RequestMapping("/production/pressure")
public class TFurnancePressureController extends BaseController
{
    @Autowired
    private ITFurnancePressureService tFurnancePressureService;

    @Autowired
    private TFurnancePressureMapper tFurnancePressureMapper;

    @Autowired
    private ITCommonfileService tCommonfileService;

    /**
     * 裂解炉测压列表Summary（APP）
     */
    @GetMapping("/summary")
    public AjaxResult getPressureSummary() throws ParseException {
        TFurnancePressure query = new TFurnancePressure();
        Date date = new Date();
        date.setHours(0);
        date.setMinutes(0);
        date.setSeconds(0);
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date parse = sdf.parse(sdf.format(date));
        query.setRecordTime(parse);
        List<TFurnancePressure> result = tFurnancePressureService.selectTFurnancePressureByDate(query);
        List<TFurnancePressure> list = new ArrayList<>();
        List<FurnanceSummaryVO> voList = new ArrayList<>();
        double maxValue109 = 0;
        double maxValue110 = 0;
        double maxValue111 = 0;
        double maxValue112 = 0;
        double maxValue113 = 0;
        double maxValue114 = 0;
        double maxValue115 = 0;
        double maxValue116 = 0;
        double maxValue117 = 0;
        double maxValue118 = 0;
        double maxValue130 = 0;
        for (TFurnancePressure pressure : result) {
            String furnanceName = pressure.getFurnanceName();
            switch (furnanceName) {
                case "H109":
                    double maxValue1091 = this.getMaxValue109(pressure);
                    if (maxValue1091 > maxValue109) {
                        maxValue109 = maxValue1091;
                    }
                    break;
                case "H110":
                    double maxValue1101 = this.getMaxValue11x(pressure);
                    if (maxValue1101 > maxValue110) {
                        maxValue110 = maxValue1101;
                    }
                    break;
                case "H111":
                    double maxValue1111 = this.getMaxValue11x(pressure);
                    if (maxValue1111 > maxValue111) {
                        maxValue111 = maxValue1111;
                    }
                    break;
                case "H112":
                    double maxValue1121 = this.getMaxValue11x(pressure);
                    if (maxValue1121 > maxValue112) {
                        maxValue112 = maxValue1121;
                    }
                    break;
                case "H113":
                    double maxValue1131 = this.getMaxValue11x(pressure);
                    if (maxValue1131 > maxValue113) {
                        maxValue113 = maxValue1131;
                    }
                    break;
                case "H114":
                    double maxValue1141 = this.getMaxValue11x(pressure);
                    if (maxValue1141 > maxValue114) {
                        maxValue114 = maxValue1141;
                    }
                    break;
                case "H115":
                    double maxValue151 = this.getMaxValue11x(pressure);
                    if (maxValue151 > maxValue115) {
                        maxValue115 = maxValue151;
                    }
                    break;
                case "H116":
                    double maxValue1161 = this.getMaxValue11x(pressure);
                    if (maxValue1161 > maxValue116) {
                        maxValue116 = maxValue1161;
                    }
                    break;
                case "H117":
                    double maxValue1171 = this.getMaxValue11x(pressure);
                    if (maxValue1171 > maxValue117) {
                        maxValue117 = maxValue1171;
                    }
                    break;
                case "H118":
                    double maxValue1181 = this.getMaxValue11x(pressure);
                    if (maxValue1181 > maxValue118) {
                        maxValue118 = maxValue1181;
                    }
                    break;
                case "H130":
                    double maxValue1301 = this.getMaxValue130(pressure);
                    if (maxValue1301 > maxValue130) {
                        maxValue130 = maxValue1301;
                    }
                    break;
            }
            Date recordTime = pressure.getRecordTime();
            if (recordTime.getHours() == 20) {
                list.add(pressure);
            }
        }
        for (TFurnancePressure pressure : list) {
            Long id = pressure.getId();
            String furnanceName = pressure.getFurnanceName();
            String status = pressure.getStatus();
            FurnanceSummaryVO vo = new FurnanceSummaryVO();
            vo.setId(id);
            vo.setFurnanceName(furnanceName);
            vo.setStatus(status);
            switch (furnanceName) {
                case "H109":
                    vo.setMaxValue(maxValue109);
                    break;
                case "H110":
                    vo.setMaxValue(maxValue110);
                    break;
                case "H111":
                    vo.setMaxValue(maxValue111);
                    break;
                case "H112":
                    vo.setMaxValue(maxValue112);
                    break;
                case "H113":
                    vo.setMaxValue(maxValue113);
                    break;
                case "H114":
                    vo.setMaxValue(maxValue114);
                    break;
                case "H115":
                    vo.setMaxValue(maxValue115);
                    break;
                case "H116":
                    vo.setMaxValue(maxValue116);
                    break;
                case "H117":
                    vo.setMaxValue(maxValue117);
                    break;
                case "H118":
                    vo.setMaxValue(maxValue118);
                    break;
                case "H130":
                    vo.setMaxValue(maxValue130);
                    break;
            }
            voList.add(vo);
        }
        return AjaxResult.success(voList);
    }
    public double getMaxValue109(TFurnancePressure pressure) {
        String pass1 = pressure.getPass1();
        String pass2 = pressure.getPass2();
        String pass3 = pressure.getPass3();
        String pass4 = pressure.getPass4();
        String pass5 = pressure.getPass5();
        String pass6 = pressure.getPass6();
        String pass7 = pressure.getPass7();
        String pass8 = pressure.getPass8();
        String pass9 = pressure.getPass9();
        String pass10 = pressure.getPass10();
        String pass11 = pressure.getPass11();
        String pass12 = pressure.getPass12();
        String pass13 = pressure.getPass13();
        String pass14 = pressure.getPass14();
        String pass15 = pressure.getPass15();
        String pass16 = pressure.getPass16();
        int maxValue1 = this.getMaxValue(pass1);
        int maxValue2 = this.getMaxValue(pass2);
        int maxValue3 = this.getMaxValue(pass3);
        int maxValue4 = this.getMaxValue(pass4);
        int maxValue5 = this.getMaxValue(pass5);
        int maxValue6 = this.getMaxValue(pass6);
        int maxValue7 = this.getMaxValue(pass7);
        int maxValue8 = this.getMaxValue(pass8);
        int maxValue9 = this.getMaxValue(pass9);
        int maxValue10 = this.getMaxValue(pass10);
        int maxValue11 = this.getMaxValue(pass11);
        int maxValue12 = this.getMaxValue(pass12);
        int maxValue13 = this.getMaxValue(pass13);
        int maxValue14 = this.getMaxValue(pass14);
        int maxValue15 = this.getMaxValue(pass15);
        int maxValue16 = this.getMaxValue(pass16);
        return this.getMaxValue(
            maxValue1 + "," + maxValue2 + "," + maxValue3 + "," + maxValue4 + ","
            + maxValue5 + "," + maxValue6 + "," + maxValue7 + "," + maxValue8 + ","
            + maxValue9 + "," + maxValue10 + "," + maxValue11 + "," + maxValue12 + ","
            + maxValue13 + "," + maxValue14 + "," + maxValue15 + "," + maxValue16 + ","
        );
    }
    public double getMaxValue11x(TFurnancePressure pressure) {
        String pass1 = pressure.getPass1();
        String pass2 = pressure.getPass2();
        String pass3 = pressure.getPass3();
        String pass4 = pressure.getPass4();
        String pass5 = pressure.getPass5();
        String pass6 = pressure.getPass6();
        String pass7 = pressure.getPass7();
        String pass8 = pressure.getPass8();
        int maxValue1 = this.getMaxValue(pass1);
        int maxValue2 = this.getMaxValue(pass2);
        int maxValue3 = this.getMaxValue(pass3);
        int maxValue4 = this.getMaxValue(pass4);
        int maxValue5 = this.getMaxValue(pass5);
        int maxValue6 = this.getMaxValue(pass6);
        int maxValue7 = this.getMaxValue(pass7);
        int maxValue8 = this.getMaxValue(pass8);
        return this.getMaxValue(
                maxValue1 + "," + maxValue2 + "," + maxValue3 + "," + maxValue4 + ","
                + maxValue5 + "," + maxValue6 + "," + maxValue7 + "," + maxValue8 + ","
        );
    }
    public double getMaxValue130(TFurnancePressure pressure) {
        String pass1 = pressure.getPass1();
        String pass2 = pressure.getPass2();
        String pass3 = pressure.getPass3();
        String pass4 = pressure.getPass4();
        int maxValue1 = this.getMaxValue(pass1);
        int maxValue2 = this.getMaxValue(pass2);
        int maxValue3 = this.getMaxValue(pass3);
        int maxValue4 = this.getMaxValue(pass4);
        return this.getMaxValue(maxValue1 + "," + maxValue2 + "," + maxValue3 + "," + maxValue4 + ",");
    }

    /**
     * 现场照片上传（APP）
     */
    @PostMapping("/uploadFile")
    public AjaxResult uploadFile(@RequestParam("file") MultipartFile file, String pType, String pId) throws IOException
    {
        if (!file.isEmpty())
        {
            String url = FileUploadUtils.upload(RuoYiConfig.getFilePath("/"+ pType), file);
            long size = file.getSize()/1024;
            TCommonfile tCommonfile = new TCommonfile();
            tCommonfile.setFileUrl(url);
            tCommonfile.setFileName(file.getOriginalFilename());
            tCommonfile.setCreaterCode(String.valueOf(getUserId()));
            tCommonfile.setpId(Long.parseLong(pId));
            tCommonfile.setpType(pType);
            tCommonfile.setFileSize(String.valueOf(size));
            tCommonfileService.insertTCommonfile(tCommonfile);

            AjaxResult ajax = AjaxResult.success();
            ajax.put("url", tCommonfile.getFileUrl());
            ajax.put("fileName", tCommonfile.getFileName());
            return ajax;
        }
        return AjaxResult.error("上传失败，请联系管理员");
    }

    /**
     * 获取裂解炉炉管测压fvp分析数据
     */
    @PostMapping("/getFvpAnalysis")
    public AjaxResult getFvpAnalysis(@RequestBody FvpAnalysisQueryVO fvpAnalysisQueryVO) {
        String furnanceName = fvpAnalysisQueryVO.getFurnanceName();
        furnanceName = furnanceName.replace("-", "").replace("A", "").replace("B", "");
        Date startDate = new Date(fvpAnalysisQueryVO.getRecordTime().getTime());
        startDate.setMonth(startDate.getMonth() - 3);
        Date endDate = new Date(fvpAnalysisQueryVO.getRecordTime().getTime());
        endDate.setDate(endDate.getDate() + 1);
        TFurnancePressure pressure = new TFurnancePressure();
        pressure.setFurnanceName(furnanceName);
        pressure.setStartDate(startDate);
        pressure.setEndDate(endDate);
        List<TFurnancePressure> tFurnancePressures = tFurnancePressureMapper.selectTFurnancePressureAnalysis(pressure);
        LinkedHashMap<Date, Double> resultMap = new LinkedHashMap<>();
        switch (fvpAnalysisQueryVO.getFurnanceName()) {
            case "H-110":
            case "H-111":
            case "H-112":
            case "H-113":
            case "H-114":
            case "H-115":
            case "H-116":
            case "H-117":
            case "H-118":
                resultMap = this.calcAnalysis(tFurnancePressures, fvpAnalysisQueryVO.getPass());
                break;
            case "H-130":
                resultMap = this.calcAnalysis130(tFurnancePressures, fvpAnalysisQueryVO.getPass());
                break;
            case "H-109A":
                resultMap = this.calcAnalysis109A(tFurnancePressures, fvpAnalysisQueryVO.getPass());
                break;
            case "H-109B":
                resultMap = this.calcAnalysis109B(tFurnancePressures, fvpAnalysisQueryVO.getPass());
                break;
        }
        return AjaxResult.success(resultMap);
    }
    public LinkedHashMap<Date, Double> calcAnalysis(List<TFurnancePressure> tFurnancePressures, String pass) {
        LinkedHashMap<Date, Double> map = new LinkedHashMap<>();
        if (tFurnancePressures != null && tFurnancePressures.size() != 0) {
            // pass max inlet
            double pass1Inlet = 0;
            double pass2Inlet = 0;
            double pass3Inlet = 0;
            double pass4Inlet = 0;
            double pass5Inlet = 0;
            double pass6Inlet = 0;
            double pass7Inlet = 0;
            double pass8Inlet = 0;
            // pass max outlet
            double pass1Out = 0;
            double pass2Out = 0;
            double pass3Out = 0;
            double pass4Out = 0;
            double pass5Out = 0;
            double pass6Out = 0;
            double pass7Out = 0;
            double pass8Out = 0;
            // pass ratio
            double pass1Ratio = 0;
            double pass2Ratio = 0;
            double pass3Ratio = 0;
            double pass4Ratio = 0;
            double pass5Ratio = 0;
            double pass6Ratio = 0;
            double pass7Ratio = 0;
            double pass8Ratio = 0;
            for (TFurnancePressure tFurnancePressure : tFurnancePressures) {
                String pass1Array = tFurnancePressure.getPass1();
                String pass2Array = tFurnancePressure.getPass2();
                String pass3Array = tFurnancePressure.getPass3();
                String pass4Array = tFurnancePressure.getPass4();
                String pass5Array = tFurnancePressure.getPass5();
                String pass6Array = tFurnancePressure.getPass6();
                String pass7Array = tFurnancePressure.getPass7();
                String pass8Array = tFurnancePressure.getPass8();
                if (StringUtils.isNotEmpty(pass1Array)) {
                    pass1Inlet = Double.parseDouble(pass1Array.substring(pass1Array.lastIndexOf(",")+1));
                    pass1Out = this.getMaxValue(pass1Array.substring(0, pass1Array.indexOf(",")));
                }
                if (StringUtils.isNotEmpty(pass2Array)) {
                    pass2Inlet = Double.parseDouble(pass2Array.substring(pass2Array.lastIndexOf(",")+1));
                    pass2Out = this.getMaxValue(pass2Array.substring(0, pass2Array.indexOf(",")));
                }
                if (StringUtils.isNotEmpty(pass3Array)) {
                    pass3Inlet = Double.parseDouble(pass3Array.substring(pass3Array.lastIndexOf(",")+1));
                    pass3Out = this.getMaxValue(pass3Array.substring(0, pass3Array.indexOf(",")));
                }
                if (StringUtils.isNotEmpty(pass4Array)) {
                    pass4Inlet = Double.parseDouble(pass4Array.substring(pass4Array.lastIndexOf(",")+1));
                    pass4Out = this.getMaxValue(pass4Array.substring(0, pass4Array.indexOf(",")));
                }
                if (StringUtils.isNotEmpty(pass5Array)) {
                    pass5Inlet = Double.parseDouble(pass5Array.substring(pass5Array.lastIndexOf(",")+1));
                    pass5Out = this.getMaxValue(pass5Array.substring(0, pass5Array.indexOf(",")));
                }
                if (StringUtils.isNotEmpty(pass6Array)) {
                    pass6Inlet = Double.parseDouble(pass6Array.substring(pass6Array.lastIndexOf(",")+1));
                    pass6Out = this.getMaxValue(pass6Array.substring(0, pass6Array.indexOf(",")));
                }
                if (StringUtils.isNotEmpty(pass7Array)) {
                    pass7Inlet = Double.parseDouble(pass7Array.substring(pass7Array.lastIndexOf(",")+1));
                    pass7Out = this.getMaxValue(pass7Array.substring(0, pass7Array.indexOf(",")));
                }
                if (StringUtils.isNotEmpty(pass8Array)) {
                    pass8Inlet = Double.parseDouble(pass8Array.substring(pass8Array.lastIndexOf(",")+1));
                    pass8Out = this.getMaxValue(pass8Array.substring(0, pass8Array.indexOf(",")));
                }
                DecimalFormat df = new DecimalFormat("#.00");
                if (pass1Inlet != 0 && pass1Out != 0) { pass1Ratio = Double.parseDouble(df.format(pass1Out / pass1Inlet)); }
                if (pass2Inlet != 0 && pass2Out != 0) { pass2Ratio = Double.parseDouble(df.format(pass2Out / pass2Inlet)); }
                if (pass3Inlet != 0 && pass3Out != 0) { pass3Ratio = Double.parseDouble(df.format(pass3Out / pass3Inlet)); }
                if (pass4Inlet != 0 && pass4Out != 0) { pass4Ratio = Double.parseDouble(df.format(pass4Out / pass4Inlet)); }
                if (pass5Inlet != 0 && pass5Out != 0) { pass5Ratio = Double.parseDouble(df.format(pass5Out / pass5Inlet)); }
                if (pass6Inlet != 0 && pass6Out != 0) { pass6Ratio = Double.parseDouble(df.format(pass6Out / pass6Inlet)); }
                if (pass7Inlet != 0 && pass7Out != 0) { pass7Ratio = Double.parseDouble(df.format(pass7Out / pass7Inlet)); }
                if (pass8Inlet != 0 && pass8Out != 0) { pass8Ratio = Double.parseDouble(df.format(pass8Out / pass8Inlet)); }
                Date recordTime = tFurnancePressure.getRecordTime();
                double ratio = 0;
                switch (pass) {
                    case "pass1":
                        ratio = pass1Ratio;
                        break;
                    case "pass2":
                        ratio = pass2Ratio;
                        break;
                    case "pass3":
                        ratio = pass3Ratio;
                        break;
                    case "pass4":
                        ratio = pass4Ratio;
                        break;
                    case "pass5":
                        ratio = pass5Ratio;
                        break;
                    case "pass6":
                        ratio = pass6Ratio;
                        break;
                    case "pass7":
                        ratio = pass7Ratio;
                        break;
                    case "pass8":
                        ratio = pass8Ratio;
                        break;
                    case "passAll":
                        ratio = this.getMaxDouble(new double[] {pass1Ratio,pass2Ratio,pass3Ratio,pass4Ratio,pass5Ratio,pass6Ratio,pass7Ratio,pass8Ratio});
                        break;
                }
                map.put(recordTime, ratio);
            }
            return map;
        }
        return null;
    }
    public LinkedHashMap<Date, Double> calcAnalysis109A(List<TFurnancePressure> tFurnancePressures, String pass) {
        LinkedHashMap<Date, Double> map = new LinkedHashMap<>();
        if (tFurnancePressures != null && tFurnancePressures.size() != 0) {
            // pass max inlet
            double pass1Inlet = 0;
            double pass2Inlet = 0;
            double pass3Inlet = 0;
            double pass4Inlet = 0;
            double pass5Inlet = 0;
            double pass6Inlet = 0;
            double pass7Inlet = 0;
            double pass8Inlet = 0;
            // pass max outlet
            double pass1Out = 0;
            double pass2Out = 0;
            double pass3Out = 0;
            double pass4Out = 0;
            double pass5Out = 0;
            double pass6Out = 0;
            double pass7Out = 0;
            double pass8Out = 0;
            // pass ratio
            double pass1Ratio = 0;
            double pass2Ratio = 0;
            double pass3Ratio = 0;
            double pass4Ratio = 0;
            double pass5Ratio = 0;
            double pass6Ratio = 0;
            double pass7Ratio = 0;
            double pass8Ratio = 0;
            for (TFurnancePressure tFurnancePressure : tFurnancePressures) {
                String pass1Array = tFurnancePressure.getPass1();
                String pass2Array = tFurnancePressure.getPass3();
                String pass3Array = tFurnancePressure.getPass5();
                String pass4Array = tFurnancePressure.getPass7();
                String pass5Array = tFurnancePressure.getPass9();
                String pass6Array = tFurnancePressure.getPass11();
                String pass7Array = tFurnancePressure.getPass13();
                String pass8Array = tFurnancePressure.getPass15();
                if (StringUtils.isNotEmpty(pass1Array)) {
                    pass1Inlet = Double.parseDouble(pass1Array.substring(pass1Array.lastIndexOf(",")+1));
                    pass1Out = this.getMaxValue(pass1Array.substring(0, pass1Array.indexOf(",")));
                }
                if (StringUtils.isNotEmpty(pass2Array)) {
                    pass2Inlet = Double.parseDouble(pass2Array.substring(pass2Array.lastIndexOf(",")+1));
                    pass2Out = this.getMaxValue(pass2Array.substring(0, pass2Array.indexOf(",")));
                }
                if (StringUtils.isNotEmpty(pass3Array)) {
                    pass3Inlet = Double.parseDouble(pass3Array.substring(pass3Array.lastIndexOf(",")+1));
                    pass3Out = this.getMaxValue(pass3Array.substring(0, pass3Array.indexOf(",")));
                }
                if (StringUtils.isNotEmpty(pass4Array)) {
                    pass4Inlet = Double.parseDouble(pass4Array.substring(pass4Array.lastIndexOf(",")+1));
                    pass4Out = this.getMaxValue(pass4Array.substring(0, pass4Array.indexOf(",")));
                }
                if (StringUtils.isNotEmpty(pass5Array)) {
                    pass5Inlet = Double.parseDouble(pass5Array.substring(pass5Array.lastIndexOf(",")+1));
                    pass5Out = this.getMaxValue(pass5Array.substring(0, pass5Array.indexOf(",")));
                }
                if (StringUtils.isNotEmpty(pass6Array)) {
                    pass6Inlet = Double.parseDouble(pass6Array.substring(pass6Array.lastIndexOf(",")+1));
                    pass6Out = this.getMaxValue(pass6Array.substring(0, pass6Array.indexOf(",")));
                }
                if (StringUtils.isNotEmpty(pass7Array)) {
                    pass7Inlet = Double.parseDouble(pass7Array.substring(pass7Array.lastIndexOf(",")+1));
                    pass7Out = this.getMaxValue(pass7Array.substring(0, pass7Array.indexOf(",")));
                }
                if (StringUtils.isNotEmpty(pass8Array)) {
                    pass8Inlet = Double.parseDouble(pass8Array.substring(pass8Array.lastIndexOf(",")+1));
                    pass8Out = this.getMaxValue(pass8Array.substring(0, pass8Array.indexOf(",")));
                }
                DecimalFormat df = new DecimalFormat("#.00");
                if (pass1Inlet != 0 && pass1Out != 0) { pass1Ratio = Double.parseDouble(df.format(pass1Out / pass1Inlet)); }
                if (pass2Inlet != 0 && pass2Out != 0) { pass2Ratio = Double.parseDouble(df.format(pass2Out / pass2Inlet)); }
                if (pass3Inlet != 0 && pass3Out != 0) { pass3Ratio = Double.parseDouble(df.format(pass3Out / pass3Inlet)); }
                if (pass4Inlet != 0 && pass4Out != 0) { pass4Ratio = Double.parseDouble(df.format(pass4Out / pass4Inlet)); }
                if (pass5Inlet != 0 && pass5Out != 0) { pass5Ratio = Double.parseDouble(df.format(pass5Out / pass5Inlet)); }
                if (pass6Inlet != 0 && pass6Out != 0) { pass6Ratio = Double.parseDouble(df.format(pass6Out / pass6Inlet)); }
                if (pass7Inlet != 0 && pass7Out != 0) { pass7Ratio = Double.parseDouble(df.format(pass7Out / pass7Inlet)); }
                if (pass8Inlet != 0 && pass8Out != 0) { pass8Ratio = Double.parseDouble(df.format(pass8Out / pass8Inlet)); }
                Date recordTime = tFurnancePressure.getRecordTime();
                double ratio = 0;
                switch (pass) {
                    case "pass1":
                        ratio = pass1Ratio;
                        break;
                    case "pass2":
                        ratio = pass2Ratio;
                        break;
                    case "pass3":
                        ratio = pass3Ratio;
                        break;
                    case "pass4":
                        ratio = pass4Ratio;
                        break;
                    case "pass5":
                        ratio = pass5Ratio;
                        break;
                    case "pass6":
                        ratio = pass6Ratio;
                        break;
                    case "pass7":
                        ratio = pass7Ratio;
                        break;
                    case "pass8":
                        ratio = pass8Ratio;
                        break;
                    case "passAll":
                        ratio = this.getMaxDouble(new double[] {pass1Ratio,pass2Ratio,pass3Ratio,pass4Ratio,pass5Ratio,pass6Ratio,pass7Ratio,pass8Ratio});
                        break;
                }
                map.put(recordTime, ratio);
            }
            return map;
        }
        return null;
    }
    public LinkedHashMap<Date, Double> calcAnalysis109B(List<TFurnancePressure> tFurnancePressures, String pass) {
        LinkedHashMap<Date, Double> map = new LinkedHashMap<>();
        if (tFurnancePressures != null && tFurnancePressures.size() != 0) {
            // pass max inlet
            double pass1Inlet = 0;
            double pass2Inlet = 0;
            double pass3Inlet = 0;
            double pass4Inlet = 0;
            double pass5Inlet = 0;
            double pass6Inlet = 0;
            double pass7Inlet = 0;
            double pass8Inlet = 0;
            // pass max outlet
            double pass1Out = 0;
            double pass2Out = 0;
            double pass3Out = 0;
            double pass4Out = 0;
            double pass5Out = 0;
            double pass6Out = 0;
            double pass7Out = 0;
            double pass8Out = 0;
            // pass ratio
            double pass1Ratio = 0;
            double pass2Ratio = 0;
            double pass3Ratio = 0;
            double pass4Ratio = 0;
            double pass5Ratio = 0;
            double pass6Ratio = 0;
            double pass7Ratio = 0;
            double pass8Ratio = 0;
            for (TFurnancePressure tFurnancePressure : tFurnancePressures) {
                String pass1Array = tFurnancePressure.getPass2();
                String pass2Array = tFurnancePressure.getPass4();
                String pass3Array = tFurnancePressure.getPass6();
                String pass4Array = tFurnancePressure.getPass8();
                String pass5Array = tFurnancePressure.getPass10();
                String pass6Array = tFurnancePressure.getPass12();
                String pass7Array = tFurnancePressure.getPass14();
                String pass8Array = tFurnancePressure.getPass16();
                if (StringUtils.isNotEmpty(pass1Array)) {
                    pass1Inlet = Double.parseDouble(pass1Array.substring(pass1Array.lastIndexOf(",")+1));
                    pass1Out = this.getMaxValue(pass1Array.substring(0, pass1Array.indexOf(",")));
                }
                if (StringUtils.isNotEmpty(pass2Array)) {
                    pass2Inlet = Double.parseDouble(pass2Array.substring(pass2Array.lastIndexOf(",")+1));
                    pass2Out = this.getMaxValue(pass2Array.substring(0, pass2Array.indexOf(",")));
                }
                if (StringUtils.isNotEmpty(pass3Array)) {
                    pass3Inlet = Double.parseDouble(pass3Array.substring(pass3Array.lastIndexOf(",")+1));
                    pass3Out = this.getMaxValue(pass3Array.substring(0, pass3Array.indexOf(",")));
                }
                if (StringUtils.isNotEmpty(pass4Array)) {
                    pass4Inlet = Double.parseDouble(pass4Array.substring(pass4Array.lastIndexOf(",")+1));
                    pass4Out = this.getMaxValue(pass4Array.substring(0, pass4Array.indexOf(",")));
                }
                if (StringUtils.isNotEmpty(pass5Array)) {
                    pass5Inlet = Double.parseDouble(pass5Array.substring(pass5Array.lastIndexOf(",")+1));
                    pass5Out = this.getMaxValue(pass5Array.substring(0, pass5Array.indexOf(",")));
                }
                if (StringUtils.isNotEmpty(pass6Array)) {
                    pass6Inlet = Double.parseDouble(pass6Array.substring(pass6Array.lastIndexOf(",")+1));
                    pass6Out = this.getMaxValue(pass6Array.substring(0, pass6Array.indexOf(",")));
                }
                if (StringUtils.isNotEmpty(pass7Array)) {
                    pass7Inlet = Double.parseDouble(pass7Array.substring(pass7Array.lastIndexOf(",")+1));
                    pass7Out = this.getMaxValue(pass7Array.substring(0, pass7Array.indexOf(",")));
                }
                if (StringUtils.isNotEmpty(pass8Array)) {
                    pass8Inlet = Double.parseDouble(pass8Array.substring(pass8Array.lastIndexOf(",")+1));
                    pass8Out = this.getMaxValue(pass8Array.substring(0, pass8Array.indexOf(",")));
                }
                DecimalFormat df = new DecimalFormat("#.00");
                if (pass1Inlet != 0 && pass1Out != 0) { pass1Ratio = Double.parseDouble(df.format(pass1Out / pass1Inlet)); }
                if (pass2Inlet != 0 && pass2Out != 0) { pass2Ratio = Double.parseDouble(df.format(pass2Out / pass2Inlet)); }
                if (pass3Inlet != 0 && pass3Out != 0) { pass3Ratio = Double.parseDouble(df.format(pass3Out / pass3Inlet)); }
                if (pass4Inlet != 0 && pass4Out != 0) { pass4Ratio = Double.parseDouble(df.format(pass4Out / pass4Inlet)); }
                if (pass5Inlet != 0 && pass5Out != 0) { pass5Ratio = Double.parseDouble(df.format(pass5Out / pass5Inlet)); }
                if (pass6Inlet != 0 && pass6Out != 0) { pass6Ratio = Double.parseDouble(df.format(pass6Out / pass6Inlet)); }
                if (pass7Inlet != 0 && pass7Out != 0) { pass7Ratio = Double.parseDouble(df.format(pass7Out / pass7Inlet)); }
                if (pass8Inlet != 0 && pass8Out != 0) { pass8Ratio = Double.parseDouble(df.format(pass8Out / pass8Inlet)); }
                Date recordTime = tFurnancePressure.getRecordTime();
                double ratio = 0;
                switch (pass) {
                    case "pass1":
                        ratio = pass1Ratio;
                        break;
                    case "pass2":
                        ratio = pass2Ratio;
                        break;
                    case "pass3":
                        ratio = pass3Ratio;
                        break;
                    case "pass4":
                        ratio = pass4Ratio;
                        break;
                    case "pass5":
                        ratio = pass5Ratio;
                        break;
                    case "pass6":
                        ratio = pass6Ratio;
                        break;
                    case "pass7":
                        ratio = pass7Ratio;
                        break;
                    case "pass8":
                        ratio = pass8Ratio;
                        break;
                    case "passAll":
                        ratio = this.getMaxDouble(new double[] {pass1Ratio,pass2Ratio,pass3Ratio,pass4Ratio,pass5Ratio,pass6Ratio,pass7Ratio,pass8Ratio});
                        break;
                }
                map.put(recordTime, ratio);
            }
            return map;
        }
        return null;
    }
    public LinkedHashMap<Date, Double> calcAnalysis130(List<TFurnancePressure> tFurnancePressures, String pass) {
        LinkedHashMap<Date, Double> map = new LinkedHashMap<>();
        if (tFurnancePressures != null && tFurnancePressures.size() != 0) {
            // pass max inlet
            double pass1Inlet = 0;
            double pass2Inlet = 0;
            double pass3Inlet = 0;
            double pass4Inlet = 0;
            // pass max outlet
            double pass1Out = 0;
            double pass2Out = 0;
            double pass3Out = 0;
            double pass4Out = 0;
            // pass ratio
            double pass1Ratio = 0;
            double pass2Ratio = 0;
            double pass3Ratio = 0;
            double pass4Ratio = 0;
            for (TFurnancePressure tFurnancePressure : tFurnancePressures) {
                String pass1Array = tFurnancePressure.getPass1();
                String pass2Array = tFurnancePressure.getPass2();
                String pass3Array = tFurnancePressure.getPass3();
                String pass4Array = tFurnancePressure.getPass4();
                if (StringUtils.isNotEmpty(pass1Array)) {
                    pass1Inlet = Double.parseDouble(pass1Array.substring(pass1Array.lastIndexOf(",")+1));
                    pass1Out = this.getMaxValue(pass1Array.substring(0, pass1Array.indexOf(",")));
                }
                if (StringUtils.isNotEmpty(pass2Array)) {
                    pass2Inlet = Double.parseDouble(pass2Array.substring(pass2Array.lastIndexOf(",")+1));
                    pass2Out = this.getMaxValue(pass2Array.substring(0, pass2Array.indexOf(",")));
                }
                if (StringUtils.isNotEmpty(pass3Array)) {
                    pass3Inlet = Double.parseDouble(pass3Array.substring(pass3Array.lastIndexOf(",")+1));
                    pass3Out = this.getMaxValue(pass3Array.substring(0, pass3Array.indexOf(",")));
                }
                if (StringUtils.isNotEmpty(pass4Array)) {
                    pass4Inlet = Double.parseDouble(pass4Array.substring(pass4Array.lastIndexOf(",")+1));
                    pass4Out = this.getMaxValue(pass4Array.substring(0, pass4Array.indexOf(",")));
                }
                DecimalFormat df = new DecimalFormat("#.00");
                if (pass1Inlet != 0 && pass1Out != 0) { pass1Ratio = Double.parseDouble(df.format(pass1Out / pass1Inlet)); }
                if (pass2Inlet != 0 && pass2Out != 0) { pass2Ratio = Double.parseDouble(df.format(pass2Out / pass2Inlet)); }
                if (pass3Inlet != 0 && pass3Out != 0) { pass3Ratio = Double.parseDouble(df.format(pass3Out / pass3Inlet)); }
                if (pass4Inlet != 0 && pass4Out != 0) { pass4Ratio = Double.parseDouble(df.format(pass4Out / pass4Inlet)); }
                Date recordTime = tFurnancePressure.getRecordTime();
                double ratio = 0;
                switch (pass) {
                    case "pass1":
                        ratio = pass1Ratio;
                        break;
                    case "pass2":
                        ratio = pass2Ratio;
                        break;
                    case "pass3":
                        ratio = pass3Ratio;
                        break;
                    case "pass4":
                        ratio = pass4Ratio;
                        break;
                    case "passAll":
                        ratio = this.getMaxDouble(new double[] {pass1Ratio,pass2Ratio,pass3Ratio,pass4Ratio});
                        break;
                }
                map.put(recordTime, ratio);
            }
            return map;
        }
        return null;
    }

    /**
     * 获取裂解炉炉管测压详细信息
     */
    @PostMapping("/info")
    public AjaxResult getPressureInfo(@RequestBody TFurnancePressure tFurnancePressure) throws ParseException {
        String furnanceName = tFurnancePressure.getFurnanceName();
        Date recordTime = new Date();
        if ("".equals(furnanceName) || recordTime == null) {
            return AjaxResult.success();
        }
        Date date = new Date();
        date.setYear(recordTime.getYear());
        date.setMonth(recordTime.getMonth());
        date.setDate(recordTime.getDate());
        date.setHours(0);
        date.setMinutes(0);
        date.setSeconds(0);
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date parse = sdf.parse(sdf.format(date));
        tFurnancePressure.setRecordTime(parse);
        List<TFurnancePressure> tFurnancePressures = tFurnancePressureService.selectTFurnancePressureByDate(tFurnancePressure);
        TFurnancePressure am = new TFurnancePressure();
        TFurnancePressure pm = new TFurnancePressure();
        parse.setHours(20);
        long dateTime = parse.getTime();
        tFurnancePressure.setRecordTime(recordTime);
        for (TFurnancePressure furnancePressure : tFurnancePressures) {
            long time = furnancePressure.getRecordTime().getTime();
            if (time >= dateTime) {
                pm = furnancePressure;
            } else {
                am = furnancePressure;
            }
        }
        if (recordTime.getTime() >= parse.getTime()) {
            if (pm == null ) {
                return AjaxResult.error("当天数据未生成");
            } else {
                this.isComplete(pm);
                return AjaxResult.success(pm);
            }
        } else {
            if (am == null ) {
                return AjaxResult.error("当天数据未生成");
            } else {
                this.isComplete(am);
                return AjaxResult.success(am);
            }
        }
    }
    public TFurnancePressure isComplete(TFurnancePressure tFurnancePressure) {
        String furnanceName = tFurnancePressure.getFurnanceName();
        tFurnancePressure.setProgress(0L);
        tFurnancePressure.setPass1Complete(false);
        tFurnancePressure.setPass2Complete(false);
        tFurnancePressure.setPass3Complete(false);
        tFurnancePressure.setPass4Complete(false);
        tFurnancePressure.setPass5Complete(false);
        tFurnancePressure.setPass6Complete(false);
        tFurnancePressure.setPass7Complete(false);
        tFurnancePressure.setPass8Complete(false);
        tFurnancePressure.setPass9Complete(false);
        tFurnancePressure.setPass10Complete(false);
        tFurnancePressure.setPass11Complete(false);
        tFurnancePressure.setPass12Complete(false);
        tFurnancePressure.setPass13Complete(false);
        tFurnancePressure.setPass14Complete(false);
        tFurnancePressure.setPass15Complete(false);
        tFurnancePressure.setPass16Complete(false);
        switch (furnanceName) {
            case "H109":
                this.isComplete109(tFurnancePressure);
                break;
            case "H110":
            case "H111":
            case "H112":
            case "H113":
            case "H114":
            case "H115":
            case "H116":
            case "H117":
            case "H118":
                this.isComplete11x(tFurnancePressure);
                break;
            case "H130":
                this.isComplete130(tFurnancePressure);
                break;
        }
        return tFurnancePressure;
    }
    public TFurnancePressure isComplete109(TFurnancePressure tFurnancePressure) {
        String pass1 = tFurnancePressure.getPass1();
        String pass2 = tFurnancePressure.getPass2();
        String pass3 = tFurnancePressure.getPass3();
        String pass4 = tFurnancePressure.getPass4();
        String pass5 = tFurnancePressure.getPass5();
        String pass6 = tFurnancePressure.getPass6();
        String pass7 = tFurnancePressure.getPass7();
        String pass8 = tFurnancePressure.getPass8();
        String pass9 = tFurnancePressure.getPass9();
        String pass10 = tFurnancePressure.getPass10();
        String pass11 = tFurnancePressure.getPass11();
        String pass12 = tFurnancePressure.getPass12();
        String pass13 = tFurnancePressure.getPass13();
        String pass14 = tFurnancePressure.getPass14();
        String pass15 = tFurnancePressure.getPass15();
        String pass16 = tFurnancePressure.getPass16();
        double count = 0;
        if (StringUtils.isNotNull(pass1) && StringUtils.isNotEmpty(pass1)) {
            String[] split = pass1.split(",");
            if (split.length >= 15) {
                tFurnancePressure.setPass1Complete(true);
                count++;
            }
        }
        if (StringUtils.isNotNull(pass2) && StringUtils.isNotEmpty(pass2)) {
            String[] split = pass2.split(",");
            if (split.length >= 15) {
                tFurnancePressure.setPass2Complete(true);
                count++;
            }
        }
        if (StringUtils.isNotNull(pass3) && StringUtils.isNotEmpty(pass3)) {
            String[] split = pass3.split(",");
            if (split.length >= 15) {
                tFurnancePressure.setPass3Complete(true);
                count++;
            }
        }
        if (StringUtils.isNotNull(pass4) && StringUtils.isNotEmpty(pass4)) {
            String[] split = pass4.split(",");
            if (split.length >= 15) {
                tFurnancePressure.setPass4Complete(true);
                count++;
            }
        }
        if (StringUtils.isNotNull(pass5) && StringUtils.isNotEmpty(pass5)) {
            String[] split = pass5.split(",");
            if (split.length >= 15) {
                tFurnancePressure.setPass5Complete(true);
                count++;
            }
        }
        if (StringUtils.isNotNull(pass6) && StringUtils.isNotEmpty(pass6)) {
            String[] split = pass6.split(",");
            if (split.length >= 15) {
                tFurnancePressure.setPass6Complete(true);
                count++;
            }
        }
        if (StringUtils.isNotNull(pass7) && StringUtils.isNotEmpty(pass7)) {
            String[] split = pass7.split(",");
            if (split.length >= 15) {
                tFurnancePressure.setPass7Complete(true);
                count++;
            }
        }
        if (StringUtils.isNotNull(pass8) && StringUtils.isNotEmpty(pass8)) {
            String[] split = pass8.split(",");
            if (split.length >= 15) {
                tFurnancePressure.setPass8Complete(true);
                count++;
            }
        }
        if (StringUtils.isNotNull(pass9) && StringUtils.isNotEmpty(pass9)) {
            String[] split = pass9.split(",");
            if (split.length >= 15) {
                tFurnancePressure.setPass9Complete(true);
                count++;
            }
        }
        if (StringUtils.isNotNull(pass10) && StringUtils.isNotEmpty(pass10)) {
            String[] split = pass10.split(",");
            if (split.length >= 15) {
                tFurnancePressure.setPass10Complete(true);
                count++;
            }
        }
        if (StringUtils.isNotNull(pass11) && StringUtils.isNotEmpty(pass11)) {
            String[] split = pass11.split(",");
            if (split.length >= 15) {
                tFurnancePressure.setPass11Complete(true);
                count++;
            }
        }
        if (StringUtils.isNotNull(pass12) && StringUtils.isNotEmpty(pass12)) {
            String[] split = pass12.split(",");
            if (split.length >= 15) {
                tFurnancePressure.setPass12Complete(true);
                count++;
            }
        }
        if (StringUtils.isNotNull(pass13) && StringUtils.isNotEmpty(pass13)) {
            String[] split = pass13.split(",");
            if (split.length >= 15) {
                tFurnancePressure.setPass13Complete(true);
                count++;
            }
        }
        if (StringUtils.isNotNull(pass14) && StringUtils.isNotEmpty(pass14)) {
            String[] split = pass14.split(",");
            if (split.length >= 15) {
                tFurnancePressure.setPass14Complete(true);
                count++;
            }
        }
        if (StringUtils.isNotNull(pass15) && StringUtils.isNotEmpty(pass15)) {
            String[] split = pass15.split(",");
            if (split.length >= 15) {
                tFurnancePressure.setPass15Complete(true);
                count++;
            }
        }
        if (StringUtils.isNotNull(pass16) && StringUtils.isNotEmpty(pass16)) {
            String[] split = pass16.split(",");
            if (split.length >= 15) {
                tFurnancePressure.setPass16Complete(true);
                count++;
            }
        }
        tFurnancePressure.setProgress(count * 1.00d / 16L);
        return tFurnancePressure;
    }
    public TFurnancePressure isComplete11x(TFurnancePressure tFurnancePressure) {
        String pass1 = tFurnancePressure.getPass1();
        String pass2 = tFurnancePressure.getPass2();
        String pass3 = tFurnancePressure.getPass3();
        String pass4 = tFurnancePressure.getPass4();
        String pass5 = tFurnancePressure.getPass5();
        String pass6 = tFurnancePressure.getPass6();
        String pass7 = tFurnancePressure.getPass7();
        String pass8 = tFurnancePressure.getPass8();
        double count = 0;
        if (StringUtils.isNotNull(pass1) && StringUtils.isNotEmpty(pass1)) {
            String[] split = pass1.split(",");
            if (split.length >= 11) {
                tFurnancePressure.setPass1Complete(true);
                count++;
            }
        }
        if (StringUtils.isNotNull(pass2) && StringUtils.isNotEmpty(pass2)) {
            String[] split = pass2.split(",");
            if (split.length >= 11) {
                tFurnancePressure.setPass2Complete(true);
                count++;
            }
        }
        if (StringUtils.isNotNull(pass3) && StringUtils.isNotEmpty(pass3)) {
            String[] split = pass3.split(",");
            if (split.length >= 11) {
                tFurnancePressure.setPass3Complete(true);
                count++;
            }
        }
        if (StringUtils.isNotNull(pass4) && StringUtils.isNotEmpty(pass4)) {
            String[] split = pass4.split(",");
            if (split.length >= 11) {
                tFurnancePressure.setPass4Complete(true);
                count++;
            }
        }
        if (StringUtils.isNotNull(pass5) && StringUtils.isNotEmpty(pass5)) {
            String[] split = pass5.split(",");
            if (split.length >= 11) {
                tFurnancePressure.setPass5Complete(true);
                count++;
            }
        }
        if (StringUtils.isNotNull(pass6) && StringUtils.isNotEmpty(pass6)) {
            String[] split = pass6.split(",");
            if (split.length >= 11) {
                tFurnancePressure.setPass6Complete(true);
                count++;
            }
        }
        if (StringUtils.isNotNull(pass7) && StringUtils.isNotEmpty(pass7)) {
            String[] split = pass7.split(",");
            if (split.length >= 11) {
                tFurnancePressure.setPass7Complete(true);
                count++;
            }
        }
        if (StringUtils.isNotNull(pass8) && StringUtils.isNotEmpty(pass8)) {
            String[] split = pass8.split(",");
            if (split.length >= 11) {
                tFurnancePressure.setPass8Complete(true);
                count++;
            }
        }
        tFurnancePressure.setProgress(count * 1.00d / 8L);
        return tFurnancePressure;
    }
    public TFurnancePressure isComplete130(TFurnancePressure tFurnancePressure) {
        String pass1 = tFurnancePressure.getPass1();
        String pass2 = tFurnancePressure.getPass2();
        String pass3 = tFurnancePressure.getPass3();
        String pass4 = tFurnancePressure.getPass4();
        double count = 0;
        if (StringUtils.isNotNull(pass1) && StringUtils.isNotEmpty(pass1)) {
            String[] split = pass1.split(",");
            if (split.length >= 7) {
                tFurnancePressure.setPass1Complete(true);
                count++;
            }
        }
        if (StringUtils.isNotNull(pass2) && StringUtils.isNotEmpty(pass2)) {
            String[] split = pass2.split(",");
            if (split.length >= 7) {
                tFurnancePressure.setPass2Complete(true);
                count++;
            }
        }
        if (StringUtils.isNotNull(pass3) && StringUtils.isNotEmpty(pass3)) {
            String[] split = pass3.split(",");
            if (split.length >= 7) {
                tFurnancePressure.setPass3Complete(true);
                count++;
            }
        }
        if (StringUtils.isNotNull(pass4) && StringUtils.isNotEmpty(pass4)) {
            String[] split = pass4.split(",");
            if (split.length >= 7) {
                tFurnancePressure.setPass4Complete(true);
                count++;
            }
        }
        tFurnancePressure.setProgress(count * 1.00d / 4L);
        return tFurnancePressure;
    }

    /**
     * 查询裂解炉炉管测压FVP
     */
    @GetMapping("/fvp")
    public AjaxResult fvp(TFurnancePressure tFurnancePressure) {
        tFurnancePressure.setFurnanceName("H109");
        List<TFurnancePressure> list109 = tFurnancePressureService.selectTFurnancePressureByDate(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H110");
        List<TFurnancePressure> list110 = tFurnancePressureService.selectTFurnancePressureByDate(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H111");
        List<TFurnancePressure> list111 = tFurnancePressureService.selectTFurnancePressureByDate(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H112");
        List<TFurnancePressure> list112 = tFurnancePressureService.selectTFurnancePressureByDate(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H113");
        List<TFurnancePressure> list113 = tFurnancePressureService.selectTFurnancePressureByDate(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H114");
        List<TFurnancePressure> list114 = tFurnancePressureService.selectTFurnancePressureByDate(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H115");
        List<TFurnancePressure> list115 = tFurnancePressureService.selectTFurnancePressureByDate(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H116");
        List<TFurnancePressure> list116 = tFurnancePressureService.selectTFurnancePressureByDate(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H117");
        List<TFurnancePressure> list117 = tFurnancePressureService.selectTFurnancePressureByDate(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H118");
        List<TFurnancePressure> list118 = tFurnancePressureService.selectTFurnancePressureByDate(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H130");
        List<TFurnancePressure> list130 = tFurnancePressureService.selectTFurnancePressureByDate(tFurnancePressure);
        if (list109.size() != list110.size() || list109.size() != list111.size()
                || list109.size() != list112.size() || list109.size() != list113.size()
                || list109.size() != list114.size() || list109.size() != list115.size()
                || list109.size() != list116.size() || list109.size() != list117.size()
                || list109.size() != list118.size() || list109.size() != list130.size()
                ||list109.size() == 0 || list109.size() == 0 || list109.size() == 0 || list109.size() == 0
                || list109.size() == 0 || list109.size() == 0 || list109.size() == 0 || list109.size() == 0
                || list109.size() == 0 || list109.size() == 0) {
            return AjaxResult.success("incompleteData");
        } else {
            FurnancePressureFvpVO vo109A = this.calcRatio109A(list109);
            FurnancePressureFvpVO vo109B = this.calcRatio109B(list109);
            FurnancePressureFvpVO vo110 = this.calcRatio(list110);
            FurnancePressureFvpVO vo111 = this.calcRatio(list111);
            FurnancePressureFvpVO vo112 = this.calcRatio(list112);
            FurnancePressureFvpVO vo113 = this.calcRatio(list113);
            FurnancePressureFvpVO vo114 = this.calcRatio(list114);
            FurnancePressureFvpVO vo115 = this.calcRatio(list115);
            FurnancePressureFvpVO vo116 = this.calcRatio(list116);
            FurnancePressureFvpVO vo117 = this.calcRatio(list117);
            FurnancePressureFvpVO vo118 = this.calcRatio(list118);
            FurnancePressureFvpVO vo130 = this.calcRatio130(list130);
            vo110.setFurnanceName("H-110");
            vo111.setFurnanceName("H-111");
            vo112.setFurnanceName("H-112");
            vo113.setFurnanceName("H-113");
            vo114.setFurnanceName("H-114");
            vo115.setFurnanceName("H-115");
            vo116.setFurnanceName("H-116");
            vo117.setFurnanceName("H-117");
            vo118 .setFurnanceName("H-118");
            vo130.setFurnanceName("H-130");
            vo109A.setFurnanceName("H-109A");
            vo109B.setFurnanceName("H-109B");
            List<FurnancePressureFvpVO> voList = new ArrayList<>();
            voList.add(vo110);
            voList.add(vo111);
            voList.add(vo112);
            voList.add(vo113);
            voList.add(vo114);
            voList.add(vo115);
            voList.add(vo116);
            voList.add(vo117);
            voList.add(vo118);
            voList.add(vo130);
            voList.add(vo109A);
            voList.add(vo109B);
            return AjaxResult.success(voList);
        }
    }
    public FurnancePressureFvpVO calcRatio(List<TFurnancePressure> tFurnancePressure) {
        if (tFurnancePressure != null && tFurnancePressure.size() != 0) {
            // pass max inlet
            double pass1Inlet = 0;
            double pass2Inlet = 0;
            double pass3Inlet = 0;
            double pass4Inlet = 0;
            double pass5Inlet = 0;
            double pass6Inlet = 0;
            double pass7Inlet = 0;
            double pass8Inlet = 0;
            // pass max outlet
            double pass1Out = 0;
            double pass2Out = 0;
            double pass3Out = 0;
            double pass4Out = 0;
            double pass5Out = 0;
            double pass6Out = 0;
            double pass7Out = 0;
            double pass8Out = 0;
            // pass ratio
            double pass1Ratio = 0;
            double pass2Ratio = 0;
            double pass3Ratio = 0;
            double pass4Ratio = 0;
            double pass5Ratio = 0;
            double pass6Ratio = 0;
            double pass7Ratio = 0;
            double pass8Ratio = 0;
            // 获取pass max值
            // xxx,xxx,xxx,...->xxx
            for (TFurnancePressure furnancePressure : tFurnancePressure) {
                String pass1Array = furnancePressure.getPass1();
                String pass2Array = furnancePressure.getPass2();
                String pass3Array = furnancePressure.getPass3();
                String pass4Array = furnancePressure.getPass4();
                String pass5Array = furnancePressure.getPass5();
                String pass6Array = furnancePressure.getPass6();
                String pass7Array = furnancePressure.getPass7();
                String pass8Array = furnancePressure.getPass8();
                if (StringUtils.isNotEmpty(pass1Array)) {
                    double in = Double.parseDouble(pass1Array.substring(pass1Array.lastIndexOf(",")+1));
                    double out = this.getMaxValue(pass1Array.substring(0, pass1Array.indexOf(",")));
                    if (in > pass1Inlet) { pass1Inlet = in; }
                    if (out > pass1Out) { pass1Out = out; }
                }
                if (StringUtils.isNotEmpty(pass2Array)) {
                    double in = Double.parseDouble(pass2Array.substring(pass2Array.lastIndexOf(",")+1));
                    double out = this.getMaxValue(pass2Array.substring(0, pass2Array.indexOf(",")));
                    if (in > pass2Inlet) { pass2Inlet = in; }
                    if (out > pass2Out) { pass2Out = out; }
                }
                if (StringUtils.isNotEmpty(pass3Array)) {
                    double in = Double.parseDouble(pass3Array.substring(pass3Array.lastIndexOf(",")+1));
                    double out = this.getMaxValue(pass3Array.substring(0, pass3Array.indexOf(",")));
                    if (in > pass3Inlet) { pass3Inlet = in; }
                    if (out > pass3Out) { pass3Out = out; }
                }
                if (StringUtils.isNotEmpty(pass4Array)) {
                    double in = Double.parseDouble(pass4Array.substring(pass4Array.lastIndexOf(",")+1));
                    double out = this.getMaxValue(pass4Array.substring(0, pass4Array.indexOf(",")));
                    if (in > pass4Inlet) { pass4Inlet = in; }
                    if (out > pass4Out) { pass4Out = out; }
                }
                if (StringUtils.isNotEmpty(pass5Array)) {
                    double in = Double.parseDouble(pass5Array.substring(pass5Array.lastIndexOf(",")+1));
                    double out = this.getMaxValue(pass5Array.substring(0, pass5Array.indexOf(",")));
                    if (in > pass5Inlet) { pass5Inlet = in; }
                    if (out > pass5Out) { pass5Out = out; }
                }
                if (StringUtils.isNotEmpty(pass6Array)) {
                    double in = Double.parseDouble(pass6Array.substring(pass6Array.lastIndexOf(",")+1));
                    double out = this.getMaxValue(pass6Array.substring(0, pass6Array.indexOf(",")));
                    if (in > pass6Inlet) { pass6Inlet = in; }
                    if (out > pass6Out) { pass6Out = out; }
                }
                if (StringUtils.isNotEmpty(pass7Array)) {
                    double in = Double.parseDouble(pass7Array.substring(pass7Array.lastIndexOf(",")+1));
                    double out = this.getMaxValue(pass7Array.substring(0, pass7Array.indexOf(",")));
                    if (in > pass7Inlet) { pass7Inlet = in; }
                    if (out > pass7Out) { pass7Out = out; }
                }
                if (StringUtils.isNotEmpty(pass8Array)) {
                    double in = Double.parseDouble(pass8Array.substring(pass8Array.lastIndexOf(",")+1));
                    double out = this.getMaxValue(pass8Array.substring(0, pass8Array.indexOf(",")));
                    if (in > pass8Inlet) { pass8Inlet = in; }
                    if (out > pass8Out) { pass8Out = out; }
                }
            }
            DecimalFormat df = new DecimalFormat("#.00");
            if (pass1Inlet != 0 && pass1Out != 0) { pass1Ratio = Double.parseDouble(df.format(pass1Out / pass1Inlet)); }
            if (pass2Inlet != 0 && pass2Out != 0) { pass2Ratio = Double.parseDouble(df.format(pass2Out / pass2Inlet)); }
            if (pass3Inlet != 0 && pass3Out != 0) { pass3Ratio = Double.parseDouble(df.format(pass3Out / pass3Inlet)); }
            if (pass4Inlet != 0 && pass4Out != 0) { pass4Ratio = Double.parseDouble(df.format(pass4Out / pass4Inlet)); }
            if (pass5Inlet != 0 && pass5Out != 0) { pass5Ratio = Double.parseDouble(df.format(pass5Out / pass5Inlet)); }
            if (pass6Inlet != 0 && pass6Out != 0) { pass6Ratio = Double.parseDouble(df.format(pass6Out / pass6Inlet)); }
            if (pass7Inlet != 0 && pass7Out != 0) { pass7Ratio = Double.parseDouble(df.format(pass7Out / pass7Inlet)); }
            if (pass8Inlet != 0 && pass8Out != 0) { pass8Ratio = Double.parseDouble(df.format(pass8Out / pass8Inlet)); }
            FurnancePressureFvpVO vo = new FurnancePressureFvpVO();
            vo.setPass1Inlet(pass1Inlet);
            vo.setPass2Inlet(pass2Inlet);
            vo.setPass3Inlet(pass3Inlet);
            vo.setPass4Inlet(pass4Inlet);
            vo.setPass5Inlet(pass5Inlet);
            vo.setPass6Inlet(pass6Inlet);
            vo.setPass7Inlet(pass7Inlet);
            vo.setPass8Inlet(pass8Inlet);
            vo.setPass1Out(pass1Out);
            vo.setPass2Out(pass2Out);
            vo.setPass3Out(pass3Out);
            vo.setPass4Out(pass4Out);
            vo.setPass5Out(pass5Out);
            vo.setPass6Out(pass6Out);
            vo.setPass7Out(pass7Out);
            vo.setPass8Out(pass8Out);
            vo.setPass1Ratio(pass1Ratio);
            vo.setPass2Ratio(pass2Ratio);
            vo.setPass3Ratio(pass3Ratio);
            vo.setPass4Ratio(pass4Ratio);
            vo.setPass5Ratio(pass5Ratio);
            vo.setPass6Ratio(pass6Ratio);
            vo.setPass7Ratio(pass7Ratio);
            vo.setPass8Ratio(pass8Ratio);
            vo.setAllPassMaxInlet(this.getMaxDouble(new double[] {pass1Inlet,pass2Inlet,pass3Inlet,pass4Inlet,pass5Inlet,pass6Inlet,pass7Inlet,pass8Inlet}));
            vo.setAllPassMaxOut(this.getMaxDouble(new double[] {pass1Out,pass2Out,pass3Out,pass4Out,pass5Out,pass6Out,pass7Out,pass8Out}));
            vo.setAllPassMaxRatio(this.getMaxDouble(new double[] {pass1Ratio,pass2Ratio,pass3Ratio,pass4Ratio,pass5Ratio,pass6Ratio,pass7Ratio,pass8Ratio}));
            return vo;
        } else {
            return null;
        }
    }
    public FurnancePressureFvpVO calcRatio109A(List<TFurnancePressure> tFurnancePressure) {
        if (tFurnancePressure != null && tFurnancePressure.size() != 0) {
            double pass1Inlet = 0;
            double pass2Inlet = 0;
            double pass3Inlet = 0;
            double pass4Inlet = 0;
            double pass5Inlet = 0;
            double pass6Inlet = 0;
            double pass7Inlet = 0;
            double pass8Inlet = 0;
            double pass1Out = 0;
            double pass2Out = 0;
            double pass3Out = 0;
            double pass4Out = 0;
            double pass5Out = 0;
            double pass6Out = 0;
            double pass7Out = 0;
            double pass8Out = 0;
            double pass1Ratio = 0;
            double pass2Ratio = 0;
            double pass3Ratio = 0;
            double pass4Ratio = 0;
            double pass5Ratio = 0;
            double pass6Ratio = 0;
            double pass7Ratio = 0;
            double pass8Ratio = 0;
            // 获取pass max值
            // xxx,xxx,xxx,...->xxx
            for (TFurnancePressure furnancePressure : tFurnancePressure) {
                String pass1Array = furnancePressure.getPass1();
                String pass2Array = furnancePressure.getPass3();
                String pass3Array = furnancePressure.getPass5();
                String pass4Array = furnancePressure.getPass7();
                String pass5Array = furnancePressure.getPass9();
                String pass6Array = furnancePressure.getPass11();
                String pass7Array = furnancePressure.getPass13();
                String pass8Array = furnancePressure.getPass15();
                if (StringUtils.isNotEmpty(pass1Array)) {
                    int lastIndex = pass1Array.lastIndexOf(",");
                    if (lastIndex != -1) {
                        String substring = pass1Array.substring(lastIndex + 1);
                        if (StringUtils.isNotEmpty(substring)) {
                            double in = Double.parseDouble(substring);
                            if (in > pass1Inlet) { pass1Inlet = in; }
                        }
                    }
                    int index = pass1Array.indexOf(",");
                    if (index != -1) {
                        String substring = pass1Array.substring(0, index);
                        if (StringUtils.isNotEmpty(substring)) {
                            double out = this.getMaxValue(substring);
                            if (out > pass1Out) { pass1Out = out; }
                        }
                    }
                }
                if (StringUtils.isNotEmpty(pass2Array)) {
                    int lastIndex = pass2Array.lastIndexOf(",");
                    if (lastIndex != -1) {
                        String substring = pass2Array.substring(lastIndex + 1);
                        if (StringUtils.isNotEmpty(substring)) {
                            double in = Double.parseDouble(substring);
                            if (in > pass2Inlet) { pass2Inlet = in; }
                        }
                    }
                    int index = pass2Array.indexOf(",");
                    if (index != -1) {
                        String substring = pass2Array.substring(0, index);
                        if (StringUtils.isNotEmpty(substring)) {
                            double out = this.getMaxValue(substring);
                            if (out > pass2Out) { pass2Out = out; }
                        }
                    }
                }
                if (StringUtils.isNotEmpty(pass3Array)) {
                    int lastIndex = pass3Array.lastIndexOf(",");
                    if (lastIndex != -1) {
                        String substring = pass3Array.substring(lastIndex + 1);
                        if (StringUtils.isNotEmpty(substring)) {
                            double in = Double.parseDouble(substring);
                            if (in > pass3Inlet) { pass3Inlet = in; }
                        }
                    }
                    int index = pass3Array.indexOf(",");
                    if (index != -1) {
                        String substring = pass3Array.substring(0, index);
                        if (StringUtils.isNotEmpty(substring)) {
                            double out = this.getMaxValue(substring);
                            if (out > pass3Out) { pass3Out = out; }
                        }
                    }
                }
                if (StringUtils.isNotEmpty(pass4Array)) {
                    int lastIndex = pass4Array.lastIndexOf(",");
                    if (lastIndex != -1) {
                        String substring = pass4Array.substring(lastIndex + 1);
                        if (StringUtils.isNotEmpty(substring)) {
                            double in = Double.parseDouble(substring);
                            if (in > pass4Inlet) { pass4Inlet = in; }
                        }
                    }
                    int index = pass4Array.indexOf(",");
                    if (index != -1) {
                        String substring = pass4Array.substring(0, index);
                        if (StringUtils.isNotEmpty(substring)) {
                            double out = this.getMaxValue(substring);
                            if (out > pass4Out) { pass4Out = out; }
                        }
                    }
                }
                if (StringUtils.isNotEmpty(pass5Array)) {
                    int lastIndex = pass5Array.lastIndexOf(",");
                    if (lastIndex != -1) {
                        String substring = pass5Array.substring(lastIndex + 1);
                        if (StringUtils.isNotEmpty(substring)) {
                            double in = Double.parseDouble(substring);
                            if (in > pass5Inlet) { pass5Inlet = in; }
                        }
                    }
                    int index = pass5Array.indexOf(",");
                    if (index != -1) {
                        String substring = pass5Array.substring(0, index);
                        if (StringUtils.isNotEmpty(substring)) {
                            double out = this.getMaxValue(substring);
                            if (out > pass5Out) { pass5Out = out; }
                        }
                    }
                }
                if (StringUtils.isNotEmpty(pass6Array)) {
                    int lastIndex = pass6Array.lastIndexOf(",");
                    if (lastIndex != -1) {
                        String substring = pass6Array.substring(lastIndex + 1);
                        if (StringUtils.isNotEmpty(substring)) {
                            double in = Double.parseDouble(substring);
                            if (in > pass6Inlet) { pass6Inlet = in; }
                        }
                    }
                    int index = pass6Array.indexOf(",");
                    if (index != -1) {
                        String substring = pass6Array.substring(0, index);
                        if (StringUtils.isNotEmpty(substring)) {
                            double out = this.getMaxValue(substring);
                            if (out > pass6Out) { pass6Out = out; }
                        }
                    }
                }
                if (StringUtils.isNotEmpty(pass7Array)) {
                    int lastIndex = pass7Array.lastIndexOf(",");
                    if (lastIndex != -1) {
                        String substring = pass7Array.substring(lastIndex + 1);
                        if (StringUtils.isNotEmpty(substring)) {
                            double in = Double.parseDouble(substring);
                            if (in > pass7Inlet) { pass7Inlet = in; }
                        }
                    }
                    int index = pass7Array.indexOf(",");
                    if (index != -1) {
                        String substring = pass7Array.substring(0, index);
                        if (StringUtils.isNotEmpty(substring)) {
                            double out = this.getMaxValue(substring);
                            if (out > pass7Out) { pass7Out = out; }
                        }
                    }
                }
                if (StringUtils.isNotEmpty(pass8Array)) {
                    int lastIndex = pass8Array.lastIndexOf(",");
                    if (lastIndex != -1) {
                        String substring = pass8Array.substring(lastIndex + 1);
                        if (StringUtils.isNotEmpty(substring)) {
                            double in = Double.parseDouble(substring);
                            if (in > pass8Inlet) { pass8Inlet = in; }
                        }
                    }
                    int index = pass8Array.indexOf(",");
                    if (index != -1) {
                        String substring = pass8Array.substring(0, index);
                        if (StringUtils.isNotEmpty(substring)) {
                            double out = this.getMaxValue(substring);
                            if (out > pass8Out) { pass8Out = out; }
                        }
                    }
                }
            }
            DecimalFormat df = new DecimalFormat("#.00");
            if (pass1Inlet != 0 && pass1Out != 0) { pass1Ratio = Double.parseDouble(df.format(pass1Out / pass1Inlet)); }
            if (pass2Inlet != 0 && pass2Out != 0) { pass2Ratio = Double.parseDouble(df.format(pass2Out / pass2Inlet)); }
            if (pass3Inlet != 0 && pass3Out != 0) { pass3Ratio = Double.parseDouble(df.format(pass3Out / pass3Inlet)); }
            if (pass4Inlet != 0 && pass4Out != 0) { pass4Ratio = Double.parseDouble(df.format(pass4Out / pass4Inlet)); }
            if (pass5Inlet != 0 && pass5Out != 0) { pass5Ratio = Double.parseDouble(df.format(pass5Out / pass5Inlet)); }
            if (pass6Inlet != 0 && pass6Out != 0) { pass6Ratio = Double.parseDouble(df.format(pass6Out / pass6Inlet)); }
            if (pass7Inlet != 0 && pass7Out != 0) { pass7Ratio = Double.parseDouble(df.format(pass7Out / pass7Inlet)); }
            if (pass8Inlet != 0 && pass8Out != 0) { pass8Ratio = Double.parseDouble(df.format(pass8Out / pass8Inlet)); }
            FurnancePressureFvpVO vo = new FurnancePressureFvpVO();
            vo.setPass1Inlet(pass1Inlet);
            vo.setPass2Inlet(pass2Inlet);
            vo.setPass3Inlet(pass3Inlet);
            vo.setPass4Inlet(pass4Inlet);
            vo.setPass5Inlet(pass5Inlet);
            vo.setPass6Inlet(pass6Inlet);
            vo.setPass7Inlet(pass7Inlet);
            vo.setPass8Inlet(pass8Inlet);
            vo.setPass1Out(pass1Out);
            vo.setPass2Out(pass2Out);
            vo.setPass3Out(pass3Out);
            vo.setPass4Out(pass4Out);
            vo.setPass5Out(pass5Out);
            vo.setPass6Out(pass6Out);
            vo.setPass7Out(pass7Out);
            vo.setPass8Out(pass8Out);
            vo.setPass1Ratio(pass1Ratio);
            vo.setPass2Ratio(pass2Ratio);
            vo.setPass3Ratio(pass3Ratio);
            vo.setPass4Ratio(pass4Ratio);
            vo.setPass5Ratio(pass5Ratio);
            vo.setPass6Ratio(pass6Ratio);
            vo.setPass7Ratio(pass7Ratio);
            vo.setPass8Ratio(pass8Ratio);
            vo.setAllPassMaxInlet(this.getMaxDouble(new double[] {pass1Inlet,pass2Inlet,pass3Inlet,pass4Inlet,pass5Inlet,pass6Inlet,pass7Inlet,pass8Inlet}));
            vo.setAllPassMaxOut(this.getMaxDouble(new double[] {pass1Out,pass2Out,pass3Out,pass4Out,pass5Out,pass6Out,pass7Out,pass8Out}));
            vo.setAllPassMaxRatio(this.getMaxDouble(new double[] {pass1Ratio,pass2Ratio,pass3Ratio,pass4Ratio,pass5Ratio,pass6Ratio,pass7Ratio,pass8Ratio}));
            return vo;
        } else {
            return null;
        }
    }
    public FurnancePressureFvpVO calcRatio109B(List<TFurnancePressure> tFurnancePressure) {
        if (tFurnancePressure != null && tFurnancePressure.size() != 0) {
            double pass1Inlet = 0;
            double pass2Inlet = 0;
            double pass3Inlet = 0;
            double pass4Inlet = 0;
            double pass5Inlet = 0;
            double pass6Inlet = 0;
            double pass7Inlet = 0;
            double pass8Inlet = 0;
            double pass1Out = 0;
            double pass2Out = 0;
            double pass3Out = 0;
            double pass4Out = 0;
            double pass5Out = 0;
            double pass6Out = 0;
            double pass7Out = 0;
            double pass8Out = 0;
            double pass1Ratio = 0;
            double pass2Ratio = 0;
            double pass3Ratio = 0;
            double pass4Ratio = 0;
            double pass5Ratio = 0;
            double pass6Ratio = 0;
            double pass7Ratio = 0;
            double pass8Ratio = 0;
            // 获取pass max值
            // xxx,xxx,xxx,...->xxx
            for (TFurnancePressure furnancePressure : tFurnancePressure) {
                String pass1Array = furnancePressure.getPass2();
                String pass2Array = furnancePressure.getPass4();
                String pass3Array = furnancePressure.getPass6();
                String pass4Array = furnancePressure.getPass8();
                String pass5Array = furnancePressure.getPass10();
                String pass6Array = furnancePressure.getPass12();
                String pass7Array = furnancePressure.getPass14();
                String pass8Array = furnancePressure.getPass16();
                if (StringUtils.isNotEmpty(pass1Array)) {
                    int lastIndex = pass1Array.lastIndexOf(",");
                    if (lastIndex != -1) {
                        String substring = pass1Array.substring(lastIndex + 1);
                        if (StringUtils.isNotEmpty(substring)) {
                            double in = Double.parseDouble(substring);
                            if (in > pass1Inlet) { pass1Inlet = in; }
                        }
                    }
                    int index = pass1Array.indexOf(",");
                    if (index != -1) {
                        String substring = pass1Array.substring(0, index);
                        if (StringUtils.isNotEmpty(substring)) {
                            double out = this.getMaxValue(substring);
                            if (out > pass1Out) { pass1Out = out; }
                        }
                    }
                }
                if (StringUtils.isNotEmpty(pass2Array)) {
                    int lastIndex = pass2Array.lastIndexOf(",");
                    if (lastIndex != -1) {
                        String substring = pass2Array.substring(lastIndex + 1);
                        if (StringUtils.isNotEmpty(substring)) {
                            double in = Double.parseDouble(substring);
                            if (in > pass2Inlet) { pass2Inlet = in; }
                        }
                    }
                    int index = pass2Array.indexOf(",");
                    if (index != -1) {
                        String substring = pass2Array.substring(0, index);
                        if (StringUtils.isNotEmpty(substring)) {
                            double out = this.getMaxValue(substring);
                            if (out > pass2Out) { pass2Out = out; }
                        }
                    }
                }
                if (StringUtils.isNotEmpty(pass3Array)) {
                    int lastIndex = pass3Array.lastIndexOf(",");
                    if (lastIndex != -1) {
                        String substring = pass3Array.substring(lastIndex + 1);
                        if (StringUtils.isNotEmpty(substring)) {
                            double in = Double.parseDouble(substring);
                            if (in > pass3Inlet) { pass3Inlet = in; }
                        }
                    }
                    int index = pass3Array.indexOf(",");
                    if (index != -1) {
                        String substring = pass3Array.substring(0, index);
                        if (StringUtils.isNotEmpty(substring)) {
                            double out = this.getMaxValue(substring);
                            if (out > pass3Out) { pass3Out = out; }
                        }
                    }
                }
                if (StringUtils.isNotEmpty(pass4Array)) {
                    int lastIndex = pass4Array.lastIndexOf(",");
                    if (lastIndex != -1) {
                        String substring = pass4Array.substring(lastIndex + 1);
                        if (StringUtils.isNotEmpty(substring)) {
                            double in = Double.parseDouble(substring);
                            if (in > pass4Inlet) { pass4Inlet = in; }
                        }
                    }
                    int index = pass4Array.indexOf(",");
                    if (index != -1) {
                        String substring = pass4Array.substring(0, index);
                        if (StringUtils.isNotEmpty(substring)) {
                            double out = this.getMaxValue(substring);
                            if (out > pass4Out) { pass4Out = out; }
                        }
                    }
                }
                if (StringUtils.isNotEmpty(pass5Array)) {
                    int lastIndex = pass5Array.lastIndexOf(",");
                    if (lastIndex != -1) {
                        String substring = pass5Array.substring(lastIndex + 1);
                        if (StringUtils.isNotEmpty(substring)) {
                            double in = Double.parseDouble(substring);
                            if (in > pass5Inlet) { pass5Inlet = in; }
                        }
                    }
                    int index = pass5Array.indexOf(",");
                    if (index != -1) {
                        String substring = pass5Array.substring(0, index);
                        if (StringUtils.isNotEmpty(substring)) {
                            double out = this.getMaxValue(substring);
                            if (out > pass5Out) { pass5Out = out; }
                        }
                    }
                }
                if (StringUtils.isNotEmpty(pass6Array)) {
                    int lastIndex = pass6Array.lastIndexOf(",");
                    if (lastIndex != -1) {
                        String substring = pass6Array.substring(lastIndex + 1);
                        if (StringUtils.isNotEmpty(substring)) {
                            double in = Double.parseDouble(substring);
                            if (in > pass6Inlet) { pass6Inlet = in; }
                        }
                    }
                    int index = pass6Array.indexOf(",");
                    if (index != -1) {
                        String substring = pass6Array.substring(0, index);
                        if (StringUtils.isNotEmpty(substring)) {
                            double out = this.getMaxValue(substring);
                            if (out > pass6Out) { pass6Out = out; }
                        }
                    }
                }
                if (StringUtils.isNotEmpty(pass7Array)) {
                    int lastIndex = pass7Array.lastIndexOf(",");
                    if (lastIndex != -1) {
                        String substring = pass7Array.substring(lastIndex + 1);
                        if (StringUtils.isNotEmpty(substring)) {
                            double in = Double.parseDouble(substring);
                            if (in > pass7Inlet) { pass7Inlet = in; }
                        }
                    }
                    int index = pass7Array.indexOf(",");
                    if (index != -1) {
                        String substring = pass7Array.substring(0, index);
                        if (StringUtils.isNotEmpty(substring)) {
                            double out = this.getMaxValue(substring);
                            if (out > pass7Out) { pass7Out = out; }
                        }
                    }
                }
                if (StringUtils.isNotEmpty(pass8Array)) {
                    int lastIndex = pass8Array.lastIndexOf(",");
                    if (lastIndex != -1) {
                        String substring = pass8Array.substring(lastIndex + 1);
                        if (StringUtils.isNotEmpty(substring)) {
                            double in = Double.parseDouble(substring);
                            if (in > pass8Inlet) { pass8Inlet = in; }
                        }
                    }
                    int index = pass8Array.indexOf(",");
                    if (index != -1) {
                        String substring = pass8Array.substring(0, index);
                        if (StringUtils.isNotEmpty(substring)) {
                            double out = this.getMaxValue(substring);
                            if (out > pass8Out) { pass8Out = out; }
                        }
                    }
                }
            }
            DecimalFormat df = new DecimalFormat("#.00");
            if (pass1Inlet != 0 && pass1Out != 0) { pass1Ratio = Double.parseDouble(df.format(pass1Out / pass1Inlet)); }
            if (pass2Inlet != 0 && pass2Out != 0) { pass2Ratio = Double.parseDouble(df.format(pass2Out / pass2Inlet)); }
            if (pass3Inlet != 0 && pass3Out != 0) { pass3Ratio = Double.parseDouble(df.format(pass3Out / pass3Inlet)); }
            if (pass4Inlet != 0 && pass4Out != 0) { pass4Ratio = Double.parseDouble(df.format(pass4Out / pass4Inlet)); }
            if (pass5Inlet != 0 && pass5Out != 0) { pass5Ratio = Double.parseDouble(df.format(pass5Out / pass5Inlet)); }
            if (pass6Inlet != 0 && pass6Out != 0) { pass6Ratio = Double.parseDouble(df.format(pass6Out / pass6Inlet)); }
            if (pass7Inlet != 0 && pass7Out != 0) { pass7Ratio = Double.parseDouble(df.format(pass7Out / pass7Inlet)); }
            if (pass8Inlet != 0 && pass8Out != 0) { pass8Ratio = Double.parseDouble(df.format(pass8Out / pass8Inlet)); }
            FurnancePressureFvpVO vo = new FurnancePressureFvpVO();
            vo.setPass1Inlet(pass1Inlet);
            vo.setPass2Inlet(pass2Inlet);
            vo.setPass3Inlet(pass3Inlet);
            vo.setPass4Inlet(pass4Inlet);
            vo.setPass5Inlet(pass5Inlet);
            vo.setPass6Inlet(pass6Inlet);
            vo.setPass7Inlet(pass7Inlet);
            vo.setPass8Inlet(pass8Inlet);
            vo.setPass1Out(pass1Out);
            vo.setPass2Out(pass2Out);
            vo.setPass3Out(pass3Out);
            vo.setPass4Out(pass4Out);
            vo.setPass5Out(pass5Out);
            vo.setPass6Out(pass6Out);
            vo.setPass7Out(pass7Out);
            vo.setPass8Out(pass8Out);
            vo.setPass1Ratio(pass1Ratio);
            vo.setPass2Ratio(pass2Ratio);
            vo.setPass3Ratio(pass3Ratio);
            vo.setPass4Ratio(pass4Ratio);
            vo.setPass5Ratio(pass5Ratio);
            vo.setPass6Ratio(pass6Ratio);
            vo.setPass7Ratio(pass7Ratio);
            vo.setPass8Ratio(pass8Ratio);
            vo.setAllPassMaxInlet(this.getMaxDouble(new double[] {pass1Inlet,pass2Inlet,pass3Inlet,pass4Inlet,pass5Inlet,pass6Inlet,pass7Inlet,pass8Inlet}));
            vo.setAllPassMaxOut(this.getMaxDouble(new double[] {pass1Out,pass2Out,pass3Out,pass4Out,pass5Out,pass6Out,pass7Out,pass8Out}));
            vo.setAllPassMaxRatio(this.getMaxDouble(new double[] {pass1Ratio,pass2Ratio,pass3Ratio,pass4Ratio,pass5Ratio,pass6Ratio,pass7Ratio,pass8Ratio}));
            return vo;
        } else {
            return null;
        }
    }
    public FurnancePressureFvpVO calcRatio130(List<TFurnancePressure> tFurnancePressure) {
        if (tFurnancePressure != null && tFurnancePressure.size() != 0) {
            double pass1Inlet = 0;
            double pass2Inlet = 0;
            double pass3Inlet = 0;
            double pass4Inlet = 0;
            double pass1Out = 0;
            double pass2Out = 0;
            double pass3Out = 0;
            double pass4Out = 0;
            double pass1Ratio = 0;
            double pass2Ratio = 0;
            double pass3Ratio = 0;
            double pass4Ratio = 0;
            // 获取pass max值
            // xxx,xxx,xxx,...->xxx
            for (TFurnancePressure furnancePressure : tFurnancePressure) {
                String pass1Array = furnancePressure.getPass1();
                String pass2Array = furnancePressure.getPass2();
                String pass3Array = furnancePressure.getPass3();
                String pass4Array = furnancePressure.getPass4();
                if (StringUtils.isNotEmpty(pass1Array)) {
                    int lastIndex = pass1Array.lastIndexOf(",");
                    if (lastIndex != -1) {
                        String substring = pass1Array.substring(lastIndex + 1);
                        if (StringUtils.isNotEmpty(substring)) {
                            double in = Double.parseDouble(substring);
                            if (in > pass1Inlet) { pass1Inlet = in; }
                        }
                    }
                    int index = pass1Array.indexOf(",");
                    if (index != -1) {
                        String substring = pass1Array.substring(0, index);
                        if (StringUtils.isNotEmpty(substring)) {
                            double out = this.getMaxValue(substring);
                            if (out > pass1Out) { pass1Out = out; }
                        }
                    }
                }
                if (StringUtils.isNotEmpty(pass2Array)) {
                    int lastIndex = pass2Array.lastIndexOf(",");
                    if (lastIndex != -1) {
                        String substring = pass2Array.substring(lastIndex + 1);
                        if (StringUtils.isNotEmpty(substring)) {
                            double in = Double.parseDouble(substring);
                            if (in > pass2Inlet) { pass2Inlet = in; }
                        }
                    }
                    int index = pass2Array.indexOf(",");
                    if (index != -1) {
                        String substring = pass2Array.substring(0, index);
                        if (StringUtils.isNotEmpty(substring)) {
                            double out = this.getMaxValue(substring);
                            if (out > pass2Out) { pass2Out = out; }
                        }
                    }
                }
                if (StringUtils.isNotEmpty(pass3Array)) {
                    int lastIndex = pass3Array.lastIndexOf(",");
                    if (lastIndex != -1) {
                        String substring = pass3Array.substring(lastIndex + 1);
                        if (StringUtils.isNotEmpty(substring)) {
                            double in = Double.parseDouble(substring);
                            if (in > pass3Inlet) { pass3Inlet = in; }
                        }
                    }
                    int index = pass3Array.indexOf(",");
                    if (index != -1) {
                        String substring = pass3Array.substring(0, index);
                        if (StringUtils.isNotEmpty(substring)) {
                            double out = this.getMaxValue(substring);
                            if (out > pass3Out) { pass3Out = out; }
                        }
                    }
                }
                if (StringUtils.isNotEmpty(pass4Array)) {
                    int lastIndex = pass4Array.lastIndexOf(",");
                    if (lastIndex != -1) {
                        String substring = pass4Array.substring(lastIndex + 1);
                        if (StringUtils.isNotEmpty(substring)) {
                            double in = Double.parseDouble(substring);
                            if (in > pass4Inlet) { pass4Inlet = in; }
                        }
                    }
                    int index = pass4Array.indexOf(",");
                    if (index != -1) {
                        String substring = pass4Array.substring(0, index);
                        if (StringUtils.isNotEmpty(substring)) {
                            double out = this.getMaxValue(substring);
                            if (out > pass4Out) { pass4Out = out; }
                        }
                    }
                }
            }
            DecimalFormat df = new DecimalFormat("#.00");
            if (pass1Inlet != 0 && pass1Out != 0) { pass1Ratio = Double.parseDouble(df.format(pass1Out / pass1Inlet)); }
            if (pass2Inlet != 0 && pass2Out != 0) { pass2Ratio = Double.parseDouble(df.format(pass2Out / pass2Inlet)); }
            if (pass3Inlet != 0 && pass3Out != 0) { pass3Ratio = Double.parseDouble(df.format(pass3Out / pass3Inlet)); }
            if (pass4Inlet != 0 && pass4Out != 0) { pass4Ratio = Double.parseDouble(df.format(pass4Out / pass4Inlet)); }
            FurnancePressureFvpVO vo = new FurnancePressureFvpVO();
            vo.setPass1Inlet(pass1Inlet);
            vo.setPass2Inlet(pass2Inlet);
            vo.setPass3Inlet(pass3Inlet);
            vo.setPass4Inlet(pass4Inlet);
            vo.setPass1Out(pass1Out);
            vo.setPass2Out(pass2Out);
            vo.setPass3Out(pass3Out);
            vo.setPass4Out(pass4Out);
            vo.setPass1Ratio(pass1Ratio);
            vo.setPass2Ratio(pass2Ratio);
            vo.setPass3Ratio(pass3Ratio);
            vo.setPass4Ratio(pass4Ratio);
            vo.setAllPassMaxInlet(this.getMaxDouble(new double[] {pass1Inlet,pass2Inlet,pass3Inlet,pass4Inlet}));
            vo.setAllPassMaxOut(this.getMaxDouble(new double[] {pass1Out,pass2Out,pass3Out,pass4Out}));
            vo.setAllPassMaxRatio(this.getMaxDouble(new double[] {pass1Ratio,pass2Ratio,pass3Ratio,pass4Ratio}));
            return vo;
        } else {
            return null;
        }
    }
    public double getMaxDouble(double[] list) {
        double max = list[0];
        for (int i = 1; i < list.length; i++) {
            if (list[i] > max) {
                max = list[i];
            }
        }
        return max;
    }

    /**
     * 查询裂解炉炉管测压MAX
     */
    @GetMapping("/max")
    public AjaxResult max(TFurnancePressure tFurnancePressure)
    {
        tFurnancePressure.setFurnanceName("H109");
        List<TFurnancePressure> list109 = tFurnancePressureService.selectTFurnancePressureList(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H110");
        List<TFurnancePressure> list110 = tFurnancePressureService.selectTFurnancePressureList(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H111");
        List<TFurnancePressure> list111 = tFurnancePressureService.selectTFurnancePressureList(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H112");
        List<TFurnancePressure> list112 = tFurnancePressureService.selectTFurnancePressureList(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H113");
        List<TFurnancePressure> list113 = tFurnancePressureService.selectTFurnancePressureList(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H114");
        List<TFurnancePressure> list114 = tFurnancePressureService.selectTFurnancePressureList(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H115");
        List<TFurnancePressure> list115 = tFurnancePressureService.selectTFurnancePressureList(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H116");
        List<TFurnancePressure> list116 = tFurnancePressureService.selectTFurnancePressureList(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H117");
        List<TFurnancePressure> list117 = tFurnancePressureService.selectTFurnancePressureList(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H118");
        List<TFurnancePressure> list118 = tFurnancePressureService.selectTFurnancePressureList(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H130");
        List<TFurnancePressure> list130 = tFurnancePressureService.selectTFurnancePressureList(tFurnancePressure);
        if (list109.size() != list110.size() || list109.size() != list111.size()
                || list109.size() != list112.size() || list109.size() != list113.size()
                || list109.size() != list114.size() || list109.size() != list115.size()
                || list109.size() != list116.size() || list109.size() != list117.size()
                || list109.size() != list118.size() || list109.size() != list130.size()) {
            return AjaxResult.success("incompleteData");
        }
        List<FurnancePressureVO> coilList = new ArrayList<FurnancePressureVO>(list109.size());
        if (list109.size() != 0) {
            for (int i = 0; i < list109.size(); i++) {
                TFurnancePressure ft = list109.get(i);
                FurnancePressureVO coil = new FurnancePressureVO();
                coil.setRecordTime(ft.getRecordTime());
                String pass1 = ft.getPass1();
                String pass2 = ft.getPass2();
                String pass3 = ft.getPass3();
                String pass4 = ft.getPass4();
                String pass5 = ft.getPass5();
                String pass6 = ft.getPass6();
                String pass7 = ft.getPass7();
                String pass8 = ft.getPass8();
                String pass9 = ft.getPass9();
                String pass10 = ft.getPass10();
                String pass11 = ft.getPass11();
                String pass12 = ft.getPass12();
                String pass13 = ft.getPass13();
                String pass14 = ft.getPass14();
                String pass15 = ft.getPass15();
                String pass16 = ft.getPass16();
                if ("".equals(pass1) || StringUtils.isNull(pass1)
                    || "".equals(pass2) || StringUtils.isNull(pass2)
                    || "".equals(pass3) || StringUtils.isNull(pass3)
                    || "".equals(pass4) || StringUtils.isNull(pass4)
                    || "".equals(pass5) || StringUtils.isNull(pass5)
                    || "".equals(pass6) || StringUtils.isNull(pass6)
                    || "".equals(pass7) || StringUtils.isNull(pass7)
                    || "".equals(pass8) || StringUtils.isNull(pass8)
                    || "".equals(pass9) || StringUtils.isNull(pass9)
                    || "".equals(pass10) || StringUtils.isNull(pass10)
                    || "".equals(pass11) || StringUtils.isNull(pass11)
                    || "".equals(pass12) || StringUtils.isNull(pass12)
                    || "".equals(pass13) || StringUtils.isNull(pass13)
                    || "".equals(pass14) || StringUtils.isNull(pass14)
                    || "".equals(pass15) || StringUtils.isNull(pass15)
                    || "".equals(pass16) || StringUtils.isNull(pass16)) {
                    return AjaxResult.success("incompleteData");
                }
                coil.setH109Out(this.getMaxValue(ft.getPass1() + "," + ft.getPass2()) + ","
                        + this.getMaxValue(ft.getPass3() + "," + ft.getPass4()) + ","
                        + this.getMaxValue(ft.getPass5() + "," + ft.getPass6()) + ","
                        + this.getMaxValue(ft.getPass7() + "," + ft.getPass8()) + ","
                        + this.getMaxValue(ft.getPass9() + "," + ft.getPass10()) + ","
                        + this.getMaxValue(ft.getPass11() + "," + ft.getPass12()) + ","
                        + this.getMaxValue(ft.getPass13() + "," + ft.getPass14()) + ","
                        + this.getMaxValue(ft.getPass15() + "," + ft.getPass16()));
                coilList.add(coil);
            }
        }
        if (list110.size() != 0) {
            for (int i = 0; i < list110.size(); i++) {
                TFurnancePressure ft = list110.get(i);
                String pass1 = ft.getPass1();
                String pass2 = ft.getPass2();
                String pass3 = ft.getPass3();
                String pass4 = ft.getPass4();
                String pass5 = ft.getPass5();
                String pass6 = ft.getPass6();
                String pass7 = ft.getPass7();
                String pass8 = ft.getPass8();
                if ("".equals(pass1) || StringUtils.isNull(pass1)
                        || "".equals(pass2) || StringUtils.isNull(pass2)
                        || "".equals(pass3) || StringUtils.isNull(pass3)
                        || "".equals(pass4) || StringUtils.isNull(pass4)
                        || "".equals(pass5) || StringUtils.isNull(pass5)
                        || "".equals(pass6) || StringUtils.isNull(pass6)
                        || "".equals(pass7) || StringUtils.isNull(pass7)
                        || "".equals(pass8) || StringUtils.isNull(pass8)) {
                    return AjaxResult.success("incompleteData");
                }
                coilList.get(i).setH110Out(this.getMaxValue(ft.getPass1()) + "," + this.getMaxValue(ft.getPass2()) + ","
                        + this.getMaxValue(ft.getPass3()) + "," + this.getMaxValue(ft.getPass4()) + ","
                        + this.getMaxValue(ft.getPass5()) + "," + this.getMaxValue(ft.getPass6()) + ","
                        + this.getMaxValue(ft.getPass7()) + "," + this.getMaxValue(ft.getPass8()));
            }
        }
        if (list111.size() != 0) {
            for (int i = 0; i < list111.size(); i++) {
                TFurnancePressure ft = list111.get(i);
                String pass1 = ft.getPass1();
                String pass2 = ft.getPass2();
                String pass3 = ft.getPass3();
                String pass4 = ft.getPass4();
                String pass5 = ft.getPass5();
                String pass6 = ft.getPass6();
                String pass7 = ft.getPass7();
                String pass8 = ft.getPass8();
                if ("".equals(pass1) || StringUtils.isNull(pass1)
                        || "".equals(pass2) || StringUtils.isNull(pass2)
                        || "".equals(pass3) || StringUtils.isNull(pass3)
                        || "".equals(pass4) || StringUtils.isNull(pass4)
                        || "".equals(pass5) || StringUtils.isNull(pass5)
                        || "".equals(pass6) || StringUtils.isNull(pass6)
                        || "".equals(pass7) || StringUtils.isNull(pass7)
                        || "".equals(pass8) || StringUtils.isNull(pass8)) {
                    return AjaxResult.success("incompleteData");
                }
                coilList.get(i).setH111Out(this.getMaxValue(ft.getPass1()) + "," + this.getMaxValue(ft.getPass2()) + ","
                        + this.getMaxValue(ft.getPass3()) + "," + this.getMaxValue(ft.getPass4()) + ","
                        + this.getMaxValue(ft.getPass5()) + "," + this.getMaxValue(ft.getPass6()) + ","
                        + this.getMaxValue(ft.getPass7()) + "," + this.getMaxValue(ft.getPass8()));
            }
        }
        if (list112.size() != 0) {
            for (int i = 0; i < list112.size(); i++) {
                TFurnancePressure ft = list112.get(i);
                String pass1 = ft.getPass1();
                String pass2 = ft.getPass2();
                String pass3 = ft.getPass3();
                String pass4 = ft.getPass4();
                String pass5 = ft.getPass5();
                String pass6 = ft.getPass6();
                String pass7 = ft.getPass7();
                String pass8 = ft.getPass8();
                if ("".equals(pass1) || StringUtils.isNull(pass1)
                        || "".equals(pass2) || StringUtils.isNull(pass2)
                        || "".equals(pass3) || StringUtils.isNull(pass3)
                        || "".equals(pass4) || StringUtils.isNull(pass4)
                        || "".equals(pass5) || StringUtils.isNull(pass5)
                        || "".equals(pass6) || StringUtils.isNull(pass6)
                        || "".equals(pass7) || StringUtils.isNull(pass7)
                        || "".equals(pass8) || StringUtils.isNull(pass8)) {
                    return AjaxResult.success("incompleteData");
                }
                coilList.get(i).setH112Out(this.getMaxValue(ft.getPass1()) + "," + this.getMaxValue(ft.getPass2()) + ","
                        + this.getMaxValue(ft.getPass3()) + "," + this.getMaxValue(ft.getPass4()) + ","
                        + this.getMaxValue(ft.getPass5()) + "," + this.getMaxValue(ft.getPass6()) + ","
                        + this.getMaxValue(ft.getPass7()) + "," + this.getMaxValue(ft.getPass8()));
            }
        }
        if (list113.size() != 0) {
            for (int i = 0; i < list113.size(); i++) {
                TFurnancePressure ft = list113.get(i);
                String pass1 = ft.getPass1();
                String pass2 = ft.getPass2();
                String pass3 = ft.getPass3();
                String pass4 = ft.getPass4();
                String pass5 = ft.getPass5();
                String pass6 = ft.getPass6();
                String pass7 = ft.getPass7();
                String pass8 = ft.getPass8();
                if ("".equals(pass1) || StringUtils.isNull(pass1)
                        || "".equals(pass2) || StringUtils.isNull(pass2)
                        || "".equals(pass3) || StringUtils.isNull(pass3)
                        || "".equals(pass4) || StringUtils.isNull(pass4)
                        || "".equals(pass5) || StringUtils.isNull(pass5)
                        || "".equals(pass6) || StringUtils.isNull(pass6)
                        || "".equals(pass7) || StringUtils.isNull(pass7)
                        || "".equals(pass8) || StringUtils.isNull(pass8)) {
                    return AjaxResult.success("incompleteData");
                }
                coilList.get(i).setH113Out(this.getMaxValue(ft.getPass1()) + "," + this.getMaxValue(ft.getPass2()) + ","
                        + this.getMaxValue(ft.getPass3()) + "," + this.getMaxValue(ft.getPass4()) + ","
                        + this.getMaxValue(ft.getPass5()) + "," + this.getMaxValue(ft.getPass6()) + ","
                        + this.getMaxValue(ft.getPass7()) + "," + this.getMaxValue(ft.getPass8()));
            }
        }
        if (list114.size() != 0) {
            for (int i = 0; i < list114.size(); i++) {
                TFurnancePressure ft = list114.get(i);
                String pass1 = ft.getPass1();
                String pass2 = ft.getPass2();
                String pass3 = ft.getPass3();
                String pass4 = ft.getPass4();
                String pass5 = ft.getPass5();
                String pass6 = ft.getPass6();
                String pass7 = ft.getPass7();
                String pass8 = ft.getPass8();
                if ("".equals(pass1) || StringUtils.isNull(pass1)
                        || "".equals(pass2) || StringUtils.isNull(pass2)
                        || "".equals(pass3) || StringUtils.isNull(pass3)
                        || "".equals(pass4) || StringUtils.isNull(pass4)
                        || "".equals(pass5) || StringUtils.isNull(pass5)
                        || "".equals(pass6) || StringUtils.isNull(pass6)
                        || "".equals(pass7) || StringUtils.isNull(pass7)
                        || "".equals(pass8) || StringUtils.isNull(pass8)) {
                    return AjaxResult.success("incompleteData");
                }
                coilList.get(i).setH114Out(this.getMaxValue(ft.getPass1()) + "," + this.getMaxValue(ft.getPass2()) + ","
                        + this.getMaxValue(ft.getPass3()) + "," + this.getMaxValue(ft.getPass4()) + ","
                        + this.getMaxValue(ft.getPass5()) + "," + this.getMaxValue(ft.getPass6()) + ","
                        + this.getMaxValue(ft.getPass7()) + "," + this.getMaxValue(ft.getPass8()));
            }
        }
        if (list115.size() != 0) {
            for (int i = 0; i < list115.size(); i++) {
                TFurnancePressure ft = list115.get(i);
                String pass1 = ft.getPass1();
                String pass2 = ft.getPass2();
                String pass3 = ft.getPass3();
                String pass4 = ft.getPass4();
                String pass5 = ft.getPass5();
                String pass6 = ft.getPass6();
                String pass7 = ft.getPass7();
                String pass8 = ft.getPass8();
                if ("".equals(pass1) || StringUtils.isNull(pass1)
                        || "".equals(pass2) || StringUtils.isNull(pass2)
                        || "".equals(pass3) || StringUtils.isNull(pass3)
                        || "".equals(pass4) || StringUtils.isNull(pass4)
                        || "".equals(pass5) || StringUtils.isNull(pass5)
                        || "".equals(pass6) || StringUtils.isNull(pass6)
                        || "".equals(pass7) || StringUtils.isNull(pass7)
                        || "".equals(pass8) || StringUtils.isNull(pass8)) {
                    return AjaxResult.success("incompleteData");
                }
                coilList.get(i).setH115Out(this.getMaxValue(ft.getPass1()) + "," + this.getMaxValue(ft.getPass2()) + ","
                        + this.getMaxValue(ft.getPass3()) + "," + this.getMaxValue(ft.getPass4()) + ","
                        + this.getMaxValue(ft.getPass5()) + "," + this.getMaxValue(ft.getPass6()) + ","
                        + this.getMaxValue(ft.getPass7()) + "," + this.getMaxValue(ft.getPass8()));
            }
        }
        if (list116.size() != 0) {
            for (int i = 0; i < list116.size(); i++) {
                TFurnancePressure ft = list116.get(i);
                String pass1 = ft.getPass1();
                String pass2 = ft.getPass2();
                String pass3 = ft.getPass3();
                String pass4 = ft.getPass4();
                String pass5 = ft.getPass5();
                String pass6 = ft.getPass6();
                String pass7 = ft.getPass7();
                String pass8 = ft.getPass8();
                if ("".equals(pass1) || StringUtils.isNull(pass1)
                        || "".equals(pass2) || StringUtils.isNull(pass2)
                        || "".equals(pass3) || StringUtils.isNull(pass3)
                        || "".equals(pass4) || StringUtils.isNull(pass4)
                        || "".equals(pass5) || StringUtils.isNull(pass5)
                        || "".equals(pass6) || StringUtils.isNull(pass6)
                        || "".equals(pass7) || StringUtils.isNull(pass7)
                        || "".equals(pass8) || StringUtils.isNull(pass8)) {
                    return AjaxResult.success("incompleteData");
                }
                coilList.get(i).setH116Out(this.getMaxValue(ft.getPass1()) + "," + this.getMaxValue(ft.getPass2()) + ","
                        + this.getMaxValue(ft.getPass3()) + "," + this.getMaxValue(ft.getPass4()) + ","
                        + this.getMaxValue(ft.getPass5()) + "," + this.getMaxValue(ft.getPass6()) + ","
                        + this.getMaxValue(ft.getPass7()) + "," + this.getMaxValue(ft.getPass8()));
            }
        }
        if (list117.size() != 0) {
            for (int i = 0; i < list117.size(); i++) {
                TFurnancePressure ft = list117.get(i);
                String pass1 = ft.getPass1();
                String pass2 = ft.getPass2();
                String pass3 = ft.getPass3();
                String pass4 = ft.getPass4();
                String pass5 = ft.getPass5();
                String pass6 = ft.getPass6();
                String pass7 = ft.getPass7();
                String pass8 = ft.getPass8();
                if ("".equals(pass1) || StringUtils.isNull(pass1)
                        || "".equals(pass2) || StringUtils.isNull(pass2)
                        || "".equals(pass3) || StringUtils.isNull(pass3)
                        || "".equals(pass4) || StringUtils.isNull(pass4)
                        || "".equals(pass5) || StringUtils.isNull(pass5)
                        || "".equals(pass6) || StringUtils.isNull(pass6)
                        || "".equals(pass7) || StringUtils.isNull(pass7)
                        || "".equals(pass8) || StringUtils.isNull(pass8)) {
                    return AjaxResult.success("incompleteData");
                }
                coilList.get(i).setH117Out(this.getMaxValue(ft.getPass1()) + "," + this.getMaxValue(ft.getPass2()) + ","
                        + this.getMaxValue(ft.getPass3()) + "," + this.getMaxValue(ft.getPass4()) + ","
                        + this.getMaxValue(ft.getPass5()) + "," + this.getMaxValue(ft.getPass6()) + ","
                        + this.getMaxValue(ft.getPass7()) + "," + this.getMaxValue(ft.getPass8()));
            }
        }
        if (list118.size() != 0) {
            for (int i = 0; i < list118.size(); i++) {
                TFurnancePressure ft = list118.get(i);
                String pass1 = ft.getPass1();
                String pass2 = ft.getPass2();
                String pass3 = ft.getPass3();
                String pass4 = ft.getPass4();
                String pass5 = ft.getPass5();
                String pass6 = ft.getPass6();
                String pass7 = ft.getPass7();
                String pass8 = ft.getPass8();
                if ("".equals(pass1) || StringUtils.isNull(pass1)
                        || "".equals(pass2) || StringUtils.isNull(pass2)
                        || "".equals(pass3) || StringUtils.isNull(pass3)
                        || "".equals(pass4) || StringUtils.isNull(pass4)
                        || "".equals(pass5) || StringUtils.isNull(pass5)
                        || "".equals(pass6) || StringUtils.isNull(pass6)
                        || "".equals(pass7) || StringUtils.isNull(pass7)
                        || "".equals(pass8) || StringUtils.isNull(pass8)) {
                    return AjaxResult.success("incompleteData");
                }
                coilList.get(i).setH118Out(this.getMaxValue(ft.getPass1()) + "," + this.getMaxValue(ft.getPass2()) + ","
                        + this.getMaxValue(ft.getPass3()) + "," + this.getMaxValue(ft.getPass4()) + ","
                        + this.getMaxValue(ft.getPass5()) + "," + this.getMaxValue(ft.getPass6()) + ","
                        + this.getMaxValue(ft.getPass7()) + "," + this.getMaxValue(ft.getPass8()));
            }
        }
        if (list130.size() != 0) {
            for (int i = 0; i < list130.size(); i++) {
                TFurnancePressure ft = list130.get(i);
                String pass1 = ft.getPass1();
                String pass2 = ft.getPass2();
                String pass3 = ft.getPass3();
                String pass4 = ft.getPass4();
                String pass5 = ft.getPass5();
                String pass6 = ft.getPass6();
                String pass7 = ft.getPass7();
                String pass8 = ft.getPass8();
                String pass9 = ft.getPass9();
                String pass10 = ft.getPass10();
                String pass11 = ft.getPass11();
                String pass12 = ft.getPass12();
                if ("".equals(pass1) || StringUtils.isNull(pass1)
                        || "".equals(pass2) || StringUtils.isNull(pass2)
                        || "".equals(pass3) || StringUtils.isNull(pass3)
                        || "".equals(pass4) || StringUtils.isNull(pass4)
                        || "".equals(pass5) || StringUtils.isNull(pass5)
                        || "".equals(pass6) || StringUtils.isNull(pass6)
                        || "".equals(pass7) || StringUtils.isNull(pass7)
                        || "".equals(pass8) || StringUtils.isNull(pass8)
                        || "".equals(pass9) || StringUtils.isNull(pass9)
                        || "".equals(pass10) || StringUtils.isNull(pass10)
                        || "".equals(pass11) || StringUtils.isNull(pass11)
                        || "".equals(pass12) || StringUtils.isNull(pass12)) {
                    return AjaxResult.success("incompleteData");
                }
                coilList.get(i).setH130Out(this.getMaxValue(ft.getPass1()) + "," + this.getMaxValue(ft.getPass2()) + ","
                        + this.getMaxValue(ft.getPass3()) + "," + this.getMaxValue(ft.getPass4()) + ","
                        + this.getMaxValue(ft.getPass5()) + "," + this.getMaxValue(ft.getPass6()) + ","
                        + this.getMaxValue(ft.getPass7()) + "," + this.getMaxValue(ft.getPass8()) + ","
                        + this.getMaxValue(ft.getPass9()) + "," + this.getMaxValue(ft.getPass10()) + ","
                        + this.getMaxValue(ft.getPass11()) + "," + this.getMaxValue(ft.getPass12()));
            }
        }
        for (FurnancePressureVO vo : coilList) {
            vo.setH109Out(this.getMaxValue(vo.getH109Out())+"");
            vo.setH110Out(this.getMaxValue(vo.getH110Out())+"");
            vo.setH111Out(this.getMaxValue(vo.getH111Out())+"");
            vo.setH112Out(this.getMaxValue(vo.getH112Out())+"");
            vo.setH113Out(this.getMaxValue(vo.getH113Out())+"");
            vo.setH114Out(this.getMaxValue(vo.getH114Out())+"");
            vo.setH115Out(this.getMaxValue(vo.getH115Out())+"");
            vo.setH116Out(this.getMaxValue(vo.getH116Out())+"");
            vo.setH117Out(this.getMaxValue(vo.getH117Out())+"");
            vo.setH118Out(this.getMaxValue(vo.getH118Out())+"");
            vo.setH130Out(this.getMaxValue(vo.getH130Out())+"");
        }
        return AjaxResult.success(coilList);
    }

    /**
     * 查询裂解炉炉管测压COIL
     */
    @GetMapping("/coil")
    public AjaxResult coil(TFurnancePressure tFurnancePressure)
    {
        tFurnancePressure.setFurnanceName("H109");
        List<TFurnancePressure> list109 = tFurnancePressureService.selectTFurnancePressureList(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H110");
        List<TFurnancePressure> list110 = tFurnancePressureService.selectTFurnancePressureList(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H111");
        List<TFurnancePressure> list111 = tFurnancePressureService.selectTFurnancePressureList(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H112");
        List<TFurnancePressure> list112 = tFurnancePressureService.selectTFurnancePressureList(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H113");
        List<TFurnancePressure> list113 = tFurnancePressureService.selectTFurnancePressureList(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H114");
        List<TFurnancePressure> list114 = tFurnancePressureService.selectTFurnancePressureList(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H115");
        List<TFurnancePressure> list115 = tFurnancePressureService.selectTFurnancePressureList(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H116");
        List<TFurnancePressure> list116 = tFurnancePressureService.selectTFurnancePressureList(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H117");
        List<TFurnancePressure> list117 = tFurnancePressureService.selectTFurnancePressureList(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H118");
        List<TFurnancePressure> list118 = tFurnancePressureService.selectTFurnancePressureList(tFurnancePressure);
        tFurnancePressure.setFurnanceName("H130");
        List<TFurnancePressure> list130 = tFurnancePressureService.selectTFurnancePressureList(tFurnancePressure);
        if (list109.size() != list110.size() || list109.size() != list111.size()
                || list109.size() != list112.size() || list109.size() != list113.size()
                || list109.size() != list114.size() || list109.size() != list115.size()
                || list109.size() != list116.size() || list109.size() != list117.size()
                || list109.size() != list118.size() || list109.size() != list130.size()) {
            return AjaxResult.success("incompleteData");
        }
        List<FurnancePressureVO> coilList = new ArrayList<FurnancePressureVO>(list109.size());
        if (list109.size() != 0) {
            for (int i = 0; i < list109.size(); i++) {
                TFurnancePressure ft = list109.get(i);
                FurnancePressureVO coil = new FurnancePressureVO();
                coil.setRecordTime(ft.getRecordTime());
                String pass1 = ft.getPass1();
                String pass2 = ft.getPass2();
                String pass3 = ft.getPass3();
                String pass4 = ft.getPass4();
                String pass5 = ft.getPass5();
                String pass6 = ft.getPass6();
                String pass7 = ft.getPass7();
                String pass8 = ft.getPass8();
                String pass9 = ft.getPass9();
                String pass10 = ft.getPass10();
                String pass11 = ft.getPass11();
                String pass12 = ft.getPass12();
                String pass13 = ft.getPass13();
                String pass14 = ft.getPass14();
                String pass15 = ft.getPass15();
                String pass16 = ft.getPass16();
                if ("".equals(pass1) || StringUtils.isNull(pass1)
                        || "".equals(pass2) || StringUtils.isNull(pass2)
                        || "".equals(pass3) || StringUtils.isNull(pass3)
                        || "".equals(pass4) || StringUtils.isNull(pass4)
                        || "".equals(pass5) || StringUtils.isNull(pass5)
                        || "".equals(pass6) || StringUtils.isNull(pass6)
                        || "".equals(pass7) || StringUtils.isNull(pass7)
                        || "".equals(pass8) || StringUtils.isNull(pass8)
                        || "".equals(pass9) || StringUtils.isNull(pass9)
                        || "".equals(pass10) || StringUtils.isNull(pass10)
                        || "".equals(pass11) || StringUtils.isNull(pass11)
                        || "".equals(pass12) || StringUtils.isNull(pass12)
                        || "".equals(pass13) || StringUtils.isNull(pass13)
                        || "".equals(pass14) || StringUtils.isNull(pass14)
                        || "".equals(pass15) || StringUtils.isNull(pass15)
                        || "".equals(pass16) || StringUtils.isNull(pass16)) {
                    return AjaxResult.success("incompleteData");
                }
                coil.setH109Out(this.getMaxValue(ft.getPass1() + "," + ft.getPass2()) + ","
                        + this.getMaxValue(ft.getPass3() + "," + ft.getPass4()) + ","
                        + this.getMaxValue(ft.getPass5() + "," + ft.getPass6()) + ","
                        + this.getMaxValue(ft.getPass7() + "," + ft.getPass8()) + ","
                        + this.getMaxValue(ft.getPass9() + "," + ft.getPass10()) + ","
                        + this.getMaxValue(ft.getPass11() + "," + ft.getPass12()) + ","
                        + this.getMaxValue(ft.getPass13() + "," + ft.getPass14()) + ","
                        + this.getMaxValue(ft.getPass15() + "," + ft.getPass16()));
                coilList.add(coil);
            }
        }
        if (list110.size() != 0) {
            for (int i = 0; i < list110.size(); i++) {
                TFurnancePressure ft = list110.get(i);
                String pass1 = ft.getPass1();
                String pass2 = ft.getPass2();
                String pass3 = ft.getPass3();
                String pass4 = ft.getPass4();
                String pass5 = ft.getPass5();
                String pass6 = ft.getPass6();
                String pass7 = ft.getPass7();
                String pass8 = ft.getPass8();
                if ("".equals(pass1) || StringUtils.isNull(pass1)
                        || "".equals(pass2) || StringUtils.isNull(pass2)
                        || "".equals(pass3) || StringUtils.isNull(pass3)
                        || "".equals(pass4) || StringUtils.isNull(pass4)
                        || "".equals(pass5) || StringUtils.isNull(pass5)
                        || "".equals(pass6) || StringUtils.isNull(pass6)
                        || "".equals(pass7) || StringUtils.isNull(pass7)
                        || "".equals(pass8) || StringUtils.isNull(pass8)) {
                    return AjaxResult.success("incompleteData");
                }
                coilList.get(i).setH110Out(this.getMaxValue(ft.getPass1()) + "," + this.getMaxValue(ft.getPass2()) + ","
                        + this.getMaxValue(ft.getPass3()) + "," + this.getMaxValue(ft.getPass4()) + ","
                        + this.getMaxValue(ft.getPass5()) + "," + this.getMaxValue(ft.getPass6()) + ","
                        + this.getMaxValue(ft.getPass7()) + "," + this.getMaxValue(ft.getPass8()));
            }
        }
        if (list111.size() != 0) {
            for (int i = 0; i < list111.size(); i++) {
                TFurnancePressure ft = list111.get(i);
                String pass1 = ft.getPass1();
                String pass2 = ft.getPass2();
                String pass3 = ft.getPass3();
                String pass4 = ft.getPass4();
                String pass5 = ft.getPass5();
                String pass6 = ft.getPass6();
                String pass7 = ft.getPass7();
                String pass8 = ft.getPass8();
                if ("".equals(pass1) || StringUtils.isNull(pass1)
                        || "".equals(pass2) || StringUtils.isNull(pass2)
                        || "".equals(pass3) || StringUtils.isNull(pass3)
                        || "".equals(pass4) || StringUtils.isNull(pass4)
                        || "".equals(pass5) || StringUtils.isNull(pass5)
                        || "".equals(pass6) || StringUtils.isNull(pass6)
                        || "".equals(pass7) || StringUtils.isNull(pass7)
                        || "".equals(pass8) || StringUtils.isNull(pass8)) {
                    return AjaxResult.success("incompleteData");
                }
                coilList.get(i).setH111Out(this.getMaxValue(ft.getPass1()) + "," + this.getMaxValue(ft.getPass2()) + ","
                        + this.getMaxValue(ft.getPass3()) + "," + this.getMaxValue(ft.getPass4()) + ","
                        + this.getMaxValue(ft.getPass5()) + "," + this.getMaxValue(ft.getPass6()) + ","
                        + this.getMaxValue(ft.getPass7()) + "," + this.getMaxValue(ft.getPass8()));
            }
        }
        if (list112.size() != 0) {
            for (int i = 0; i < list112.size(); i++) {
                TFurnancePressure ft = list112.get(i);
                String pass1 = ft.getPass1();
                String pass2 = ft.getPass2();
                String pass3 = ft.getPass3();
                String pass4 = ft.getPass4();
                String pass5 = ft.getPass5();
                String pass6 = ft.getPass6();
                String pass7 = ft.getPass7();
                String pass8 = ft.getPass8();
                if ("".equals(pass1) || StringUtils.isNull(pass1)
                        || "".equals(pass2) || StringUtils.isNull(pass2)
                        || "".equals(pass3) || StringUtils.isNull(pass3)
                        || "".equals(pass4) || StringUtils.isNull(pass4)
                        || "".equals(pass5) || StringUtils.isNull(pass5)
                        || "".equals(pass6) || StringUtils.isNull(pass6)
                        || "".equals(pass7) || StringUtils.isNull(pass7)
                        || "".equals(pass8) || StringUtils.isNull(pass8)) {
                    return AjaxResult.success("incompleteData");
                }
                coilList.get(i).setH112Out(this.getMaxValue(ft.getPass1()) + "," + this.getMaxValue(ft.getPass2()) + ","
                        + this.getMaxValue(ft.getPass3()) + "," + this.getMaxValue(ft.getPass4()) + ","
                        + this.getMaxValue(ft.getPass5()) + "," + this.getMaxValue(ft.getPass6()) + ","
                        + this.getMaxValue(ft.getPass7()) + "," + this.getMaxValue(ft.getPass8()));
            }
        }
        if (list113.size() != 0) {
            for (int i = 0; i < list113.size(); i++) {
                TFurnancePressure ft = list113.get(i);
                String pass1 = ft.getPass1();
                String pass2 = ft.getPass2();
                String pass3 = ft.getPass3();
                String pass4 = ft.getPass4();
                String pass5 = ft.getPass5();
                String pass6 = ft.getPass6();
                String pass7 = ft.getPass7();
                String pass8 = ft.getPass8();
                if ("".equals(pass1) || StringUtils.isNull(pass1)
                        || "".equals(pass2) || StringUtils.isNull(pass2)
                        || "".equals(pass3) || StringUtils.isNull(pass3)
                        || "".equals(pass4) || StringUtils.isNull(pass4)
                        || "".equals(pass5) || StringUtils.isNull(pass5)
                        || "".equals(pass6) || StringUtils.isNull(pass6)
                        || "".equals(pass7) || StringUtils.isNull(pass7)
                        || "".equals(pass8) || StringUtils.isNull(pass8)) {
                    return AjaxResult.success("incompleteData");
                }
                coilList.get(i).setH113Out(this.getMaxValue(ft.getPass1()) + "," + this.getMaxValue(ft.getPass2()) + ","
                        + this.getMaxValue(ft.getPass3()) + "," + this.getMaxValue(ft.getPass4()) + ","
                        + this.getMaxValue(ft.getPass5()) + "," + this.getMaxValue(ft.getPass6()) + ","
                        + this.getMaxValue(ft.getPass7()) + "," + this.getMaxValue(ft.getPass8()));
            }
        }
        if (list114.size() != 0) {
            for (int i = 0; i < list114.size(); i++) {
                TFurnancePressure ft = list114.get(i);
                String pass1 = ft.getPass1();
                String pass2 = ft.getPass2();
                String pass3 = ft.getPass3();
                String pass4 = ft.getPass4();
                String pass5 = ft.getPass5();
                String pass6 = ft.getPass6();
                String pass7 = ft.getPass7();
                String pass8 = ft.getPass8();
                if ("".equals(pass1) || StringUtils.isNull(pass1)
                        || "".equals(pass2) || StringUtils.isNull(pass2)
                        || "".equals(pass3) || StringUtils.isNull(pass3)
                        || "".equals(pass4) || StringUtils.isNull(pass4)
                        || "".equals(pass5) || StringUtils.isNull(pass5)
                        || "".equals(pass6) || StringUtils.isNull(pass6)
                        || "".equals(pass7) || StringUtils.isNull(pass7)
                        || "".equals(pass8) || StringUtils.isNull(pass8)) {
                    return AjaxResult.success("incompleteData");
                }
                coilList.get(i).setH114Out(this.getMaxValue(ft.getPass1()) + "," + this.getMaxValue(ft.getPass2()) + ","
                        + this.getMaxValue(ft.getPass3()) + "," + this.getMaxValue(ft.getPass4()) + ","
                        + this.getMaxValue(ft.getPass5()) + "," + this.getMaxValue(ft.getPass6()) + ","
                        + this.getMaxValue(ft.getPass7()) + "," + this.getMaxValue(ft.getPass8()));
            }
        }
        if (list115.size() != 0) {
            for (int i = 0; i < list115.size(); i++) {
                TFurnancePressure ft = list115.get(i);
                String pass1 = ft.getPass1();
                String pass2 = ft.getPass2();
                String pass3 = ft.getPass3();
                String pass4 = ft.getPass4();
                String pass5 = ft.getPass5();
                String pass6 = ft.getPass6();
                String pass7 = ft.getPass7();
                String pass8 = ft.getPass8();
                if ("".equals(pass1) || StringUtils.isNull(pass1)
                        || "".equals(pass2) || StringUtils.isNull(pass2)
                        || "".equals(pass3) || StringUtils.isNull(pass3)
                        || "".equals(pass4) || StringUtils.isNull(pass4)
                        || "".equals(pass5) || StringUtils.isNull(pass5)
                        || "".equals(pass6) || StringUtils.isNull(pass6)
                        || "".equals(pass7) || StringUtils.isNull(pass7)
                        || "".equals(pass8) || StringUtils.isNull(pass8)) {
                    return AjaxResult.success("incompleteData");
                }
                coilList.get(i).setH115Out(this.getMaxValue(ft.getPass1()) + "," + this.getMaxValue(ft.getPass2()) + ","
                        + this.getMaxValue(ft.getPass3()) + "," + this.getMaxValue(ft.getPass4()) + ","
                        + this.getMaxValue(ft.getPass5()) + "," + this.getMaxValue(ft.getPass6()) + ","
                        + this.getMaxValue(ft.getPass7()) + "," + this.getMaxValue(ft.getPass8()));
            }
        }
        if (list116.size() != 0) {
            for (int i = 0; i < list116.size(); i++) {
                TFurnancePressure ft = list116.get(i);
                String pass1 = ft.getPass1();
                String pass2 = ft.getPass2();
                String pass3 = ft.getPass3();
                String pass4 = ft.getPass4();
                String pass5 = ft.getPass5();
                String pass6 = ft.getPass6();
                String pass7 = ft.getPass7();
                String pass8 = ft.getPass8();
                if ("".equals(pass1) || StringUtils.isNull(pass1)
                        || "".equals(pass2) || StringUtils.isNull(pass2)
                        || "".equals(pass3) || StringUtils.isNull(pass3)
                        || "".equals(pass4) || StringUtils.isNull(pass4)
                        || "".equals(pass5) || StringUtils.isNull(pass5)
                        || "".equals(pass6) || StringUtils.isNull(pass6)
                        || "".equals(pass7) || StringUtils.isNull(pass7)
                        || "".equals(pass8) || StringUtils.isNull(pass8)) {
                    return AjaxResult.success("incompleteData");
                }
                coilList.get(i).setH116Out(this.getMaxValue(ft.getPass1()) + "," + this.getMaxValue(ft.getPass2()) + ","
                        + this.getMaxValue(ft.getPass3()) + "," + this.getMaxValue(ft.getPass4()) + ","
                        + this.getMaxValue(ft.getPass5()) + "," + this.getMaxValue(ft.getPass6()) + ","
                        + this.getMaxValue(ft.getPass7()) + "," + this.getMaxValue(ft.getPass8()));
            }
        }
        if (list117.size() != 0) {
            for (int i = 0; i < list117.size(); i++) {
                TFurnancePressure ft = list117.get(i);
                String pass1 = ft.getPass1();
                String pass2 = ft.getPass2();
                String pass3 = ft.getPass3();
                String pass4 = ft.getPass4();
                String pass5 = ft.getPass5();
                String pass6 = ft.getPass6();
                String pass7 = ft.getPass7();
                String pass8 = ft.getPass8();
                if ("".equals(pass1) || StringUtils.isNull(pass1)
                        || "".equals(pass2) || StringUtils.isNull(pass2)
                        || "".equals(pass3) || StringUtils.isNull(pass3)
                        || "".equals(pass4) || StringUtils.isNull(pass4)
                        || "".equals(pass5) || StringUtils.isNull(pass5)
                        || "".equals(pass6) || StringUtils.isNull(pass6)
                        || "".equals(pass7) || StringUtils.isNull(pass7)
                        || "".equals(pass8) || StringUtils.isNull(pass8)) {
                    return AjaxResult.success("incompleteData");
                }
                coilList.get(i).setH117Out(this.getMaxValue(ft.getPass1()) + "," + this.getMaxValue(ft.getPass2()) + ","
                        + this.getMaxValue(ft.getPass3()) + "," + this.getMaxValue(ft.getPass4()) + ","
                        + this.getMaxValue(ft.getPass5()) + "," + this.getMaxValue(ft.getPass6()) + ","
                        + this.getMaxValue(ft.getPass7()) + "," + this.getMaxValue(ft.getPass8()));
            }
        }
        if (list118.size() != 0) {
            for (int i = 0; i < list118.size(); i++) {
                TFurnancePressure ft = list118.get(i);
                String pass1 = ft.getPass1();
                String pass2 = ft.getPass2();
                String pass3 = ft.getPass3();
                String pass4 = ft.getPass4();
                String pass5 = ft.getPass5();
                String pass6 = ft.getPass6();
                String pass7 = ft.getPass7();
                String pass8 = ft.getPass8();
                if ("".equals(pass1) || StringUtils.isNull(pass1)
                        || "".equals(pass2) || StringUtils.isNull(pass2)
                        || "".equals(pass3) || StringUtils.isNull(pass3)
                        || "".equals(pass4) || StringUtils.isNull(pass4)
                        || "".equals(pass5) || StringUtils.isNull(pass5)
                        || "".equals(pass6) || StringUtils.isNull(pass6)
                        || "".equals(pass7) || StringUtils.isNull(pass7)
                        || "".equals(pass8) || StringUtils.isNull(pass8)) {
                    return AjaxResult.success("incompleteData");
                }
                coilList.get(i).setH118Out(this.getMaxValue(ft.getPass1()) + "," + this.getMaxValue(ft.getPass2()) + ","
                        + this.getMaxValue(ft.getPass3()) + "," + this.getMaxValue(ft.getPass4()) + ","
                        + this.getMaxValue(ft.getPass5()) + "," + this.getMaxValue(ft.getPass6()) + ","
                        + this.getMaxValue(ft.getPass7()) + "," + this.getMaxValue(ft.getPass8()));
            }
        }
        if (list130.size() != 0) {
            for (int i = 0; i < list130.size(); i++) {
                TFurnancePressure ft = list130.get(i);
                String pass1 = ft.getPass1();
                String pass2 = ft.getPass2();
                String pass3 = ft.getPass3();
                String pass4 = ft.getPass4();
                String pass5 = ft.getPass5();
                String pass6 = ft.getPass6();
                String pass7 = ft.getPass7();
                String pass8 = ft.getPass8();
                String pass9 = ft.getPass9();
                String pass10 = ft.getPass10();
                String pass11 = ft.getPass11();
                String pass12 = ft.getPass12();
                if ("".equals(pass1) || StringUtils.isNull(pass1)
                        || "".equals(pass2) || StringUtils.isNull(pass2)
                        || "".equals(pass3) || StringUtils.isNull(pass3)
                        || "".equals(pass4) || StringUtils.isNull(pass4)
                        || "".equals(pass5) || StringUtils.isNull(pass5)
                        || "".equals(pass6) || StringUtils.isNull(pass6)
                        || "".equals(pass7) || StringUtils.isNull(pass7)
                        || "".equals(pass8) || StringUtils.isNull(pass8)
                        || "".equals(pass9) || StringUtils.isNull(pass9)
                        || "".equals(pass10) || StringUtils.isNull(pass10)
                        || "".equals(pass11) || StringUtils.isNull(pass11)
                        || "".equals(pass12) || StringUtils.isNull(pass12)) {
                    return AjaxResult.success("incompleteData");
                }
                coilList.get(i).setH130Out(this.getMaxValue(ft.getPass1()) + "," + this.getMaxValue(ft.getPass2()) + ","
                        + this.getMaxValue(ft.getPass3()) + "," + this.getMaxValue(ft.getPass4()) + ","
                        + this.getMaxValue(ft.getPass5()) + "," + this.getMaxValue(ft.getPass6()) + ","
                        + this.getMaxValue(ft.getPass7()) + "," + this.getMaxValue(ft.getPass8()) + ","
                        + this.getMaxValue(ft.getPass9()) + "," + this.getMaxValue(ft.getPass10()) + ","
                        + this.getMaxValue(ft.getPass11()) + "," + this.getMaxValue(ft.getPass12()));
            }
        }
        return AjaxResult.success(coilList);
    }
    public int getMaxValue(String value) {
        if (StringUtils.isNotNull(value) && StringUtils.isNotEmpty(value)) {
            String[] split = value.split(",");
            int max = Integer.parseInt(split[0]);
            for (int i = 0; i < split.length; i++) {
                int element = Integer.parseInt(split[i]);
                if (element > max) {
                    max = element;
                }
            }
            return max;
        } else {
            return 0;
        }
    }

    /**
     * 查询裂解炉炉管测压列表
     */
    @PreAuthorize("@ss.hasPermi('production:pressure:list')")
    @GetMapping("/list")
    public TableDataInfo list(TFurnancePressure tFurnancePressure)
    {
        startPage();
        List<TFurnancePressure> list = tFurnancePressureService.selectTFurnancePressureList(tFurnancePressure);
        return getDataTable(list);
    }

    /**
     * 导出裂解炉炉管测压列表
     */
    @PreAuthorize("@ss.hasPermi('production:pressure:export')")
    @Log(title = "裂解炉炉管测压", businessType = BusinessType.EXPORT)
    @GetMapping("/export")
    public AjaxResult export(TFurnancePressure tFurnancePressure)
    {
        List<TFurnancePressure> list = tFurnancePressureService.selectTFurnancePressureList(tFurnancePressure);
        ExcelUtil<TFurnancePressure> util = new ExcelUtil<TFurnancePressure>(TFurnancePressure.class);
        return util.exportExcel(list, "pressure");
    }

    /**
     * 获取裂解炉炉管测压详细信息
     */
    @PreAuthorize("@ss.hasPermi('production:pressure:query')")
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") Long id)
    {
        return AjaxResult.success(tFurnancePressureService.selectTFurnancePressureById(id));
    }

    /**
     * 新增裂解炉炉管测压
     */
    @PreAuthorize("@ss.hasPermi('production:pressure:add')")
    @Log(title = "裂解炉炉管测压", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody TFurnancePressure tFurnancePressure)
    {
        return toAjax(tFurnancePressureService.insertTFurnancePressure(tFurnancePressure));
    }

    /**
     * 修改裂解炉炉管测压
     */
    @Log(title = "裂解炉炉管测压", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody TFurnancePressure tFurnancePressure)
    {
        //更新
        tFurnancePressureService.updateTFurnancePressure(tFurnancePressure);
        //计算ratio
        TFurnancePressure pressure = tFurnancePressureService.selectTFurnancePressureById(tFurnancePressure.getId());
        String furnanceName = pressure.getFurnanceName();
        List<TFurnancePressure> list = new ArrayList();
        list.add(pressure);
        switch (furnanceName) {
            case "H109":
                FurnancePressureFvpVO furnancePressureFvpVO109A = this.calcRatio109A(list);
                FurnancePressureFvpVO furnancePressureFvpVO109B = this.calcRatio109B(list);
                this.checkRatio(furnancePressureFvpVO109A, pressure);
                this.checkRatio(furnancePressureFvpVO109B, pressure);
                break;
            case "H110":
                FurnancePressureFvpVO furnancePressureFvpVO110 = this.calcRatio(list);
                this.checkRatio(furnancePressureFvpVO110, pressure);
                break;
            case "H111":
                FurnancePressureFvpVO furnancePressureFvpVO111 = this.calcRatio(list);
                this.checkRatio(furnancePressureFvpVO111, pressure);
                break;
            case "H112":
                FurnancePressureFvpVO furnancePressureFvpVO112 = this.calcRatio(list);
                this.checkRatio(furnancePressureFvpVO112, pressure);
                break;
            case "H113":
                FurnancePressureFvpVO furnancePressureFvpVO113 = this.calcRatio(list);
                this.checkRatio(furnancePressureFvpVO113, pressure);
                break;
            case "H114":
                FurnancePressureFvpVO furnancePressureFvpVO114 = this.calcRatio(list);
                this.checkRatio(furnancePressureFvpVO114, pressure);
                break;
            case "H115":
                FurnancePressureFvpVO furnancePressureFvpVO115 = this.calcRatio(list);
                this.checkRatio(furnancePressureFvpVO115, pressure);
                break;
            case "H116":
                FurnancePressureFvpVO furnancePressureFvpVO116 = this.calcRatio(list);
                this.checkRatio(furnancePressureFvpVO116, pressure);
                break;
            case "H117":
                FurnancePressureFvpVO furnancePressureFvpVO117 = this.calcRatio(list);
                this.checkRatio(furnancePressureFvpVO117, pressure);
                break;
            case "H118":
                FurnancePressureFvpVO furnancePressureFvpVO118 = this.calcRatio(list);
                this.checkRatio(furnancePressureFvpVO118, pressure);
                break;
            case "H130":
                FurnancePressureFvpVO furnancePressureFvpVO130 = this.calcRatio130(list);
                this.checkRatio(furnancePressureFvpVO130, pressure);
                break;
        }
        //更新
        int result = tFurnancePressureService.updateTFurnancePressure(pressure);
        return AjaxResult.success(result+"", pressure);
    }
    public void checkRatio(FurnancePressureFvpVO vo, TFurnancePressure pressure) {
        double pass1Ratio = vo.getPass1Ratio();
        double pass2Ratio = vo.getPass2Ratio();
        double pass3Ratio = vo.getPass3Ratio();
        double pass4Ratio = vo.getPass4Ratio();
        double pass5Ratio = vo.getPass5Ratio();
        double pass6Ratio = vo.getPass6Ratio();
        double pass7Ratio = vo.getPass7Ratio();
        double pass8Ratio = vo.getPass8Ratio();
        if (pass1Ratio > 0.9) { pressure.setPass1RatioExceeded(true); } else { pressure.setPass1RatioExceeded(false); }
        if (pass2Ratio > 0.9) { pressure.setPass2RatioExceeded(true); } else { pressure.setPass2RatioExceeded(false); }
        if (pass3Ratio > 0.9) { pressure.setPass3RatioExceeded(true); } else { pressure.setPass3RatioExceeded(false); }
        if (pass4Ratio > 0.9) { pressure.setPass4RatioExceeded(true); } else { pressure.setPass4RatioExceeded(false); }
        if (pass5Ratio > 0.9) { pressure.setPass5RatioExceeded(true); } else { pressure.setPass5RatioExceeded(false); }
        if (pass6Ratio > 0.9) { pressure.setPass6RatioExceeded(true); } else { pressure.setPass6RatioExceeded(false); }
        if (pass7Ratio > 0.9) { pressure.setPass7RatioExceeded(true); } else { pressure.setPass7RatioExceeded(false); }
        if (pass8Ratio > 0.9) { pressure.setPass8RatioExceeded(true); } else { pressure.setPass8RatioExceeded(false); }
    }

    /**
     * 删除裂解炉炉管测压
     */
    @PreAuthorize("@ss.hasPermi('production:pressure:remove')")
    @Log(title = "裂解炉炉管测压", businessType = BusinessType.DELETE)
	@DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable Long[] ids)
    {
        return toAjax(tFurnancePressureService.deleteTFurnancePressureByIds(ids));
    }
}
