package com.ruoyi.project.training.bccnew.controller;

import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.framework.aspectj.lang.annotation.Log;
import com.ruoyi.framework.aspectj.lang.enums.BusinessType;
import com.ruoyi.framework.web.controller.BaseController;
import com.ruoyi.framework.web.domain.AjaxResult;
import com.ruoyi.framework.web.page.TableDataInfo;
import com.ruoyi.project.system.domain.SysUser;
import com.ruoyi.project.system.service.ISysUserService;
import com.ruoyi.project.training.bccnew.domain.TTsFlplan;
import com.ruoyi.project.training.bccnew.domain.TTsFtplan;
import com.ruoyi.project.training.bccnew.domain.TTsNew;
import com.ruoyi.project.training.bccnew.service.ITTsApproveService;
import com.ruoyi.project.training.bccnew.service.ITTsFirstplanService;
import com.ruoyi.project.training.bccnew.service.ITTsFtplanService;
import com.ruoyi.project.training.bccnew.service.ITTsNewService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 芳烃培训Controller
 *
 * @author ssy
 * @date 2024-06-13
 */
@RestController
@RequestMapping("/bccnew/ftplandsdt")
public class TTsFtplanController extends BaseController {
    @Autowired
    private ITTsFtplanService tTsFtplanService;
    @Autowired
    private ITTsNewService tTsNewService;
    @Autowired
    private ISysUserService sysUserService;

    @Autowired
    private ITTsFirstplanService tTsFirstplanService;

    @Autowired
    private ITTsApproveService tTsApproveService;

    /**
     * 查询芳烃培训列表
     */
    @GetMapping("/list")
    public TableDataInfo list(TTsFtplan tTsFtplan) {
        startPage();
        List<TTsFtplan> list = tTsFtplanService.selectTTsFtplanList(tTsFtplan);
        return getDataTable(list);
    }

    /**
     * 导出芳烃培训列表
     */
    @Log(title = "芳烃培训", businessType = BusinessType.EXPORT)
    @GetMapping("/export")
    public AjaxResult export(TTsFtplan tTsFtplan) {
        List<TTsFtplan> list = tTsFtplanService.selectTTsFtplanList(tTsFtplan);
        ExcelUtil<TTsFtplan> util = new ExcelUtil<TTsFtplan>(TTsFtplan.class);
        return util.exportExcel(list, "ftplandsdt");
    }

    /**
     * 获取芳烃培训详细信息
     */
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") Long id) {
        return AjaxResult.success(tTsFtplanService.selectTTsFtplanById(id));
    }

    /**
     * 新增芳烃培训
     */
    @Log(title = "芳烃培训", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody TTsFtplan tTsFtplan) {
        return toAjax(tTsFtplanService.insertTTsFtplan(tTsFtplan));
    }

    @Log(title = "芳烃培训", businessType = BusinessType.UPDATE)
    @PutMapping("/updateFtLearnTime")
    public AjaxResult updateFtLearnTime(@RequestBody TTsFtplan tTsFtplan) {
        Long userId = getUserId();
        TTsNew tTsNew = tTsNewService.selectTTsNewById(tTsFtplan.getNewId());
        SysUser sysUser = sysUserService.selectUserByStaffId(tTsNew.getStaffId());
        if (userId.equals(sysUser.getUserId())) {
            TTsFtplan need = tTsFtplanService.selectTTsFtplanById(tTsFtplan.getId());
            long timer = need.getTimer() == null ? 0 : need.getTimer();
            need.setTimer(timer + 1);
            if (need.getTimerNeed()==null)
                need.setTimerNeed(0L);
            if (need.getTimerNeed() != null && need.getTimerNeed()<=timer + 1) {
                need.setPlanStatus(2L);
            }
            return toAjax(tTsFtplanService.updateTTsFtplan(need));
        }
        return AjaxResult.error("当前登录用户非学习用户!");
    }

    /**
     * 修改芳烃培训
     */
    @Log(title = "芳烃培训", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody TTsFtplan tTsFtplan) {
        if ("好".equals(tTsFtplan.getScore1())) {
            tTsFtplan.setPlanStatus(5L);
        }
        if ("满意".equals(tTsFtplan.getScore1()) && "好".equals(tTsFtplan.getScore2())) {
            tTsFtplan.setPlanStatus(5L);
        }
        if ("满意".equals(tTsFtplan.getScore1()) && "满意".equals(tTsFtplan.getScore2()) && "好".equals(tTsFtplan.getScore3())) {
            tTsFtplan.setPlanStatus(5L);
        }
        if ("满意".equals(tTsFtplan.getScore1()) && "差".equals(tTsFtplan.getScore2()) && "好".equals(tTsFtplan.getScore2())) {
            tTsFtplan.setPlanStatus(5L);
        }
        if ("差".equals(tTsFtplan.getScore1()) && "好".equals(tTsFtplan.getScore2())) {
            tTsFtplan.setPlanStatus(5L);
        }
        if ("差".equals(tTsFtplan.getScore1()) && "满意".equals(tTsFtplan.getScore2())) {
            tTsFtplan.setPlanStatus(4L);
        }
        if ("差".equals(tTsFtplan.getScore1()) && "差".equals(tTsFtplan.getScore2())) {
            tTsFtplan.setPlanStatus(4L);
        }
        tTsFtplanService.updateTTsFtplan(tTsFtplan);
        if (tTsFtplan.getPlanStatus() == 5) {
            TTsNew tTsNew = new TTsNew();
            tTsNew.setPlanStatus(5L);
            tTsNew.setPlanType(4L);
            tTsNew.setNewId(tTsFtplan.getNewId());
            tTsNewService.updateTTsNew(tTsNew, getUserId(), getNickName());
        } else if (tTsFtplan.getPlanStatus() == 4) {
            TTsNew tTsNew = new TTsNew();
            tTsNew.setPlanStatus(4L);
            tTsNew.setPlanType(4L);
            tTsNew.setNewId(tTsFtplan.getNewId());
            tTsNewService.updateTTsNew(tTsNew, getUserId(), getNickName());
        }
        return toAjax(1);
    }

    /**
     * 删除芳烃培训
     */
    @Log(title = "芳烃培训", businessType = BusinessType.DELETE)
    @DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable Long[] ids) {
        return toAjax(tTsFtplanService.deleteTTsFtplanByIds(ids));
    }
}
