package com.ruoyi.project.training.bccnew.controller;

import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.framework.aspectj.lang.annotation.Log;
import com.ruoyi.framework.aspectj.lang.enums.BusinessType;
import com.ruoyi.framework.web.controller.BaseController;
import com.ruoyi.framework.web.domain.AjaxResult;
import com.ruoyi.framework.web.page.TableDataInfo;
import com.ruoyi.project.system.domain.SysUser;
import com.ruoyi.project.system.service.ISysUserService;
import com.ruoyi.project.training.bccnew.domain.TTsFlplan;
import com.ruoyi.project.training.bccnew.domain.TTsLjplan;
import com.ruoyi.project.training.bccnew.domain.TTsNew;
import com.ruoyi.project.training.bccnew.service.ITTsApproveService;
import com.ruoyi.project.training.bccnew.service.ITTsFirstplanService;
import com.ruoyi.project.training.bccnew.service.ITTsLjplanService;
import com.ruoyi.project.training.bccnew.service.ITTsNewService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 裂解培训Controller
 *
 * @author ssy
 * @date 2024-06-13
 */
@RestController
@RequestMapping("/bccnew/ljplandsdt")
public class TTsLjplanController extends BaseController {
    @Autowired
    private ITTsLjplanService tTsLjplanService;
    @Autowired
    private ITTsNewService tTsNewService;
    @Autowired
    private ISysUserService sysUserService;

    @Autowired
    private ITTsFirstplanService tTsFirstplanService;

    @Autowired
    private ITTsApproveService tTsApproveService;

    /**
     * 查询裂解培训列表
     */
    @GetMapping("/list")
    public TableDataInfo list(TTsLjplan tTsLjplan) {
        startPage();
        List<TTsLjplan> list = tTsLjplanService.selectTTsLjplanList(tTsLjplan);
        return getDataTable(list);
    }

    /**
     * 导出裂解培训列表
     */
    @Log(title = "裂解培训", businessType = BusinessType.EXPORT)
    @GetMapping("/export")
    public AjaxResult export(TTsLjplan tTsLjplan) {
        List<TTsLjplan> list = tTsLjplanService.selectTTsLjplanList(tTsLjplan);
        ExcelUtil<TTsLjplan> util = new ExcelUtil<TTsLjplan>(TTsLjplan.class);
        return util.exportExcel(list, "ljplandsdt");
    }

    /**
     * 获取裂解培训详细信息
     */
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") Long id) {
        return AjaxResult.success(tTsLjplanService.selectTTsLjplanById(id));
    }

    /**
     * 新增裂解培训
     */
    @Log(title = "裂解培训", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody TTsLjplan tTsLjplan) {
        return toAjax(tTsLjplanService.insertTTsLjplan(tTsLjplan));
    }

    /**
     * 修改裂解培训
     */
    @Log(title = "裂解培训", businessType = BusinessType.UPDATE)
    @PutMapping("/updateLjLearnTime")
    public AjaxResult updateLjLearnTime(@RequestBody TTsLjplan tTsLjplan) {
        Long userId = getUserId();
        TTsNew tTsNew = tTsNewService.selectTTsNewById(tTsLjplan.getNewId());
        SysUser sysUser = sysUserService.selectUserByStaffId(tTsNew.getStaffId());
        if (userId.equals(sysUser.getUserId())) {
            TTsLjplan need = tTsLjplanService.selectTTsLjplanById(tTsLjplan.getId());
            long timer = need.getTimer() == null ? 0 : need.getTimer();
            need.setTimer(timer + 1);
            if (need.getTimerNeed()==null)
                need.setTimerNeed(0L);
            if (need.getTimerNeed() != null && need.getTimerNeed()<=timer + 1) {
                need.setPlanStatus(2L);
            }
            return toAjax(tTsLjplanService.updateTTsLjplan(need));
        }
        return AjaxResult.error("当前登录用户非学习用户!");
    }


    /**
     * 修改裂解培训
     */
    @Log(title = "裂解培训", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody TTsLjplan tTsLjplan) {
        if ("好".equals(tTsLjplan.getScore1())) {
            tTsLjplan.setPlanStatus(5L);
        }
        if ("满意".equals(tTsLjplan.getScore1()) && "好".equals(tTsLjplan.getScore2())) {
            tTsLjplan.setPlanStatus(5L);
        }
        if ("满意".equals(tTsLjplan.getScore1()) && "满意".equals(tTsLjplan.getScore2()) && "好".equals(tTsLjplan.getScore3())) {
            tTsLjplan.setPlanStatus(5L);
        }
        if ("满意".equals(tTsLjplan.getScore1()) && "差".equals(tTsLjplan.getScore2()) && "好".equals(tTsLjplan.getScore2())) {
            tTsLjplan.setPlanStatus(5L);
        }
        if ("差".equals(tTsLjplan.getScore1()) && "好".equals(tTsLjplan.getScore2())) {
            tTsLjplan.setPlanStatus(5L);
        }
        if ("差".equals(tTsLjplan.getScore1()) && "满意".equals(tTsLjplan.getScore2())) {
            tTsLjplan.setPlanStatus(4L);
        }
        if ("差".equals(tTsLjplan.getScore1()) && "差".equals(tTsLjplan.getScore2())) {
            tTsLjplan.setPlanStatus(4L);
        }
        tTsLjplanService.updateTTsLjplan(tTsLjplan);
        if (tTsLjplan.getPlanStatus() == 5) {
            TTsNew tTsNew = new TTsNew();
            tTsNew.setPlanStatus(5L);
            tTsNew.setNewId(tTsLjplan.getNewId());
            tTsNew.setPlanType(1L);
            tTsNewService.updateTTsNew(tTsNew, getUserId(), getNickName());

        } else if (tTsLjplan.getPlanStatus() == 4) {
            TTsNew tTsNew = new TTsNew();
            tTsNew.setPlanStatus(4L);
            tTsNew.setNewId(tTsLjplan.getNewId());
            tTsNew.setPlanType(1L);
            tTsNewService.updateTTsNew(tTsNew, getUserId(), getNickName());
        }
        return toAjax(1);
    }

    /**
     * 删除裂解培训
     */
    @Log(title = "裂解培训", businessType = BusinessType.DELETE)
    @DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable Long[] ids) {
        return toAjax(tTsLjplanService.deleteTTsLjplanByIds(ids));
    }
}
