package com.ruoyi.project.training.bccnew.service.impl;

import com.ruoyi.project.training.bccnew.domain.*;
import com.ruoyi.project.training.bccnew.mapper.*;
import com.ruoyi.project.training.bccnew.service.ITTsApproveService;
import com.ruoyi.project.training.bccnew.service.ITTsNewService;
import org.apache.commons.collections4.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 导师带徒Service业务层处理
 *
 * @author ssy
 * @date 2024-05-20
 */
@Service
public class TTsNewServiceImpl implements ITTsNewService {
    @Autowired
    private TTsNewMapper tTsNewMapper;

    @Autowired
    private TTsLjplanTmplMapper tTsLjplanTmplMapper;

    @Autowired
    private TTsLjplanMapper tTsLjplanMapper;


    @Autowired
    private TTsYsplanTmplMapper tTsYsplanTmplMapper;

    @Autowired
    private TTsYsplanMapper tTsYsplanMapper;


    @Autowired
    private TTsFlplanTmplMapper tTsFlplanTmplMapper;

    @Autowired
    private TTsFlplanMapper tTsFlplanMapper;


    @Autowired
    private TTsFtplanTmplMapper tTsFtplanTmplMapper;

    @Autowired
    private TTsFtplanMapper tTsFtplanMapper;

    @Autowired
    private TTsFirstplanMapper tTsFirstplanMapper;

    @Autowired
    private TTsFirstplanTmplMapper tTsFirstplanTmplMapper;

    @Autowired
    private ITTsApproveService tsApproveService;

    /**
     * 查询导师带徒
     *
     * @param newId 导师带徒ID
     * @return 导师带徒
     */
    @Override
    public TTsNew selectTTsNewById(Long newId) {
        return tTsNewMapper.selectTTsNewById(newId);
    }

    /**
     * 查询导师带徒列表
     *
     * @param tTsNew 导师带徒
     * @return 导师带徒
     */
    @Override
    public List<TTsNew> selectTTsNewList(TTsNew tTsNew) {
        return tTsNewMapper.selectTTsNewList(tTsNew);
    }

    /**
     * 新增导师带徒
     *
     * @param tTsNew 导师带徒
     * @return 结果
     */
    @Override
    public int insertTTsNew(TTsNew tTsNew) {
        tTsNewMapper.insertTTsNew(tTsNew);
        for (TTsFirstplanTmpl tTsFirstplanTmpl : tTsFirstplanTmplMapper.selectTTsFirstplanTmplList(new TTsFirstplanTmpl())) {
            TTsFirstplan tTsFirstplan = new TTsFirstplan();
            tTsFirstplan.setNewId(tTsNew.getNewId());
            tTsFirstplan.setCourseCode(tTsFirstplanTmpl.getCourseCode());
            tTsFirstplan.setTopic(tTsFirstplanTmpl.getTopic());
            tTsFirstplan.setContent(tTsFirstplanTmpl.getContent());
            tTsFirstplan.setCourseDay(tTsFirstplanTmpl.getCourseDay());
            tTsFirstplan.setCourseHour(tTsFirstplanTmpl.getCourseHour());
            tTsFirstplan.setCourseType(tTsFirstplanTmpl.getCourseType());
            tTsFirstplan.setTrainer(tTsFirstplanTmpl.getTrainer());
            tTsFirstplan.setCourseDate(tTsFirstplanTmpl.getCourseDate());
            tTsFirstplan.setAssess(tTsFirstplanTmpl.getAssess());
            tTsFirstplan.setPlanStatus(0L);
            tTsFirstplan.setFileName(tTsFirstplanTmpl.getFileName());
            tTsFirstplan.setFileUrl(tTsFirstplanTmpl.getFileUrl());
            tTsFirstplan.setTimerNeed(tTsFirstplanTmpl.getTimerNeed());
            tTsFirstplan.setTimer(0L);
            tTsFirstplan.setSortTmpl(tTsFirstplanTmpl.getSortTmpl());
            tTsFirstplan.setMaterialVer(tTsFirstplanTmpl.getMaterialVer());
            tTsFirstplan.setExamType(tTsFirstplanTmpl.getExamType());
            tTsFirstplan.setExamId(tTsFirstplanTmpl.getExamId());
            tTsFirstplanMapper.insertTTsFirstplan(tTsFirstplan);
        }
        if (tTsNew.getPlanType() == 1) {
            for (TTsLjplanTmpl item : tTsLjplanTmplMapper.selectTTsLjplanTmplList(new TTsLjplanTmpl())) {
                TTsLjplan entity = new TTsLjplan();
                entity.setCourseCode(item.getCourseCode());
                entity.setTopic(item.getTopic());
                entity.setContent(item.getContent());
                entity.setCourseDay(item.getCourseDay());
                entity.setCourseHour(item.getCourseHour());
                entity.setDetailPlan(item.getDetailPlan());
                entity.setTrainer(item.getTrainer());
                entity.setCourseDate(item.getCourseDate());
                entity.setAssess(item.getAssess());
                entity.setNewId(tTsNew.getNewId());
                entity.setFileName(item.getFileName());
                entity.setFileUrl(item.getFileUrl());
                entity.setTimerNeed(item.getTimerNeed());
                entity.setTimer(0L);
                entity.setSortTmpl(item.getSortTmpl());
                entity.setPlanStatus(0L);
                tTsLjplanMapper.insertTTsLjplan(entity);
            }
        } else if (tTsNew.getPlanType() == 2) {
            for (TTsYsplanTmpl item : tTsYsplanTmplMapper.selectTTsYsplanTmplList(new TTsYsplanTmpl())) {
                TTsYsplan entity = new TTsYsplan();
                entity.setCourseCode(item.getCourseCode());
                entity.setTopic(item.getTopic());
                entity.setContent(item.getContent());
                entity.setCourseDay(item.getCourseDay());
                entity.setCourseHour(item.getCourseHour());
                entity.setDetailPlan(item.getDetailPlan());
                entity.setTrainer(item.getTrainer());
                entity.setCourseDate(item.getCourseDate());
                entity.setAssess(item.getAssess());
                entity.setNewId(tTsNew.getNewId());
                entity.setFileName(item.getFileName());
                entity.setFileUrl(item.getFileUrl());
                entity.setTimerNeed(item.getTimerNeed());
                entity.setTimer(0L);
                entity.setSortTmpl(item.getSortTmpl());
                entity.setPlanStatus(0L);
                tTsYsplanMapper.insertTTsYsplan(entity);
            }
        } else if (tTsNew.getPlanType() == 3) {
            for (TTsFlplanTmpl item : tTsFlplanTmplMapper.selectTTsFlplanTmplList(new TTsFlplanTmpl())) {
                TTsFlplan entity = new TTsFlplan();
                entity.setCourseCode(item.getCourseCode());
                entity.setTopic(item.getTopic());
                entity.setContent(item.getContent());
                entity.setCourseDay(item.getCourseDay());
                entity.setCourseHour(item.getCourseHour());
                entity.setDetailPlan(item.getDetailPlan());
                entity.setTrainer(item.getTrainer());
                entity.setCourseDate(item.getCourseDate());
                entity.setAssess(item.getAssess());
                entity.setNewId(tTsNew.getNewId());
                entity.setFileName(item.getFileName());
                entity.setFileUrl(item.getFileUrl());
                entity.setTimerNeed(item.getTimerNeed());
                entity.setTimer(0L);
                entity.setSortTmpl(item.getSortTmpl());
                entity.setPlanStatus(0L);
                tTsFlplanMapper.insertTTsFlplan(entity);
            }
        } else if (tTsNew.getPlanType() == 4) {
            for (TTsFtplanTmpl item : tTsFtplanTmplMapper.selectTTsFtplanTmplList(new TTsFtplanTmpl())) {
                TTsFtplan entity = new TTsFtplan();
                entity.setCourseCode(item.getCourseCode());
                entity.setTopic(item.getTopic());
                entity.setContent(item.getContent());
                entity.setCourseDay(item.getCourseDay());
                entity.setCourseHour(item.getCourseHour());
                entity.setDetailPlan(item.getDetailPlan());
                entity.setTrainer(item.getTrainer());
                entity.setCourseDate(item.getCourseDate());
                entity.setAssess(item.getAssess());
                entity.setNewId(tTsNew.getNewId());
                entity.setFileName(item.getFileName());
                entity.setFileUrl(item.getFileUrl());
                entity.setTimerNeed(item.getTimerNeed());
                entity.setTimer(0L);
                entity.setSortTmpl(item.getSortTmpl());
                entity.setPlanStatus(0L);
                tTsFtplanMapper.insertTTsFtplan(entity);
            }
        }
        return 1;
    }

    /**
     * 修改导师带徒
     *
     * @param tTsNew 导师带徒
     * @return 结果
     */
    @Override
    public int updateTTsNew(TTsNew tTsNew) {
        return tTsNewMapper.updateTTsNew(tTsNew);
    }

        @Override
    public int updateTTsNew(TTsNew tTsNew, Long userId, String nickName) {
        TTsNew tsNew = tTsNewMapper.selectTTsNewById(tTsNew.getNewId());
        if (tTsNew.getPlanStatus() == 1) {
            TTsFirstplan tTsFirstplan = new TTsFirstplan();
            tTsFirstplan.setNewId(tTsNew.getNewId());
            for (TTsFirstplan tsFirstplan : tTsFirstplanMapper.selectTTsFirstplanListByNewId(tTsFirstplan)) {
                tsFirstplan.setPlanStatus(1L);
                tTsFirstplanMapper.updateTTsFirstplan(tsFirstplan);
            }
            if (tsNew.getPlanType() == 1) {
                TTsLjplan entity = new TTsLjplan();
                entity.setNewId(tTsNew.getNewId());
                for (TTsLjplan item : tTsLjplanMapper.selectTTsLjplanListByNewId(entity)) {
                    item.setPlanStatus(1L);
                    tTsLjplanMapper.updateTTsLjplan(item);
                }
            } else if (tsNew.getPlanType() == 2) {
                TTsYsplan entity = new TTsYsplan();
                entity.setNewId(tTsNew.getNewId());
                for (TTsYsplan item : tTsYsplanMapper.selectTTsYsplanListByNewId(entity)) {
                    item.setPlanStatus(1L);
                    tTsYsplanMapper.updateTTsYsplan(item);
                }
            } else if (tsNew.getPlanType() == 3) {
                TTsFlplan entity = new TTsFlplan();
                entity.setNewId(tTsNew.getNewId());
                for (TTsFlplan item : tTsFlplanMapper.selectTTsFlplanListByNewId(entity)) {
                    item.setPlanStatus(1L);
                    tTsFlplanMapper.updateTTsFlplan(item);
                }
            } else if (tsNew.getPlanType() == 4) {
                TTsFtplan entity = new TTsFtplan();
                entity.setNewId(tTsNew.getNewId());
                for (TTsFtplan item : tTsFtplanMapper.selectTTsFtplanListByNewId(entity)) {
                    item.setPlanStatus(1L);
                    tTsFtplanMapper.updateTTsFtplan(item);
                }
            }
            tTsNewMapper.updateTTsNew(tTsNew);
        }
        if (tTsNew.getPlanStatus() == 3) {
            TTsFirstplan tTsFirstplan = new TTsFirstplan();
            tTsFirstplan.setNewId(tTsNew.getNewId());
            for (TTsFirstplan tsFirstplan : tTsFirstplanMapper.selectTTsFirstplanListByNewId(tTsFirstplan)) {
                tsFirstplan.setPlanStatus(3L);
                tTsFirstplanMapper.updateTTsFirstplan(tsFirstplan);
            }
            if (tsNew.getPlanType() == 1) {
                TTsLjplan entity = new TTsLjplan();
                entity.setNewId(tTsNew.getNewId());
                for (TTsLjplan item : tTsLjplanMapper.selectTTsLjplanListByNewId(entity)) {
                    item.setPlanStatus(3L);
                    tTsLjplanMapper.updateTTsLjplan(item);
                }
            } else if (tsNew.getPlanType() == 2) {
                TTsYsplan entity = new TTsYsplan();
                entity.setNewId(tTsNew.getNewId());
                for (TTsYsplan item : tTsYsplanMapper.selectTTsYsplanListByNewId(entity)) {
                    item.setPlanStatus(3L);
                    tTsYsplanMapper.updateTTsYsplan(item);
                }
            } else if (tsNew.getPlanType() == 3) {
                TTsFlplan entity = new TTsFlplan();
                entity.setNewId(tTsNew.getNewId());
                for (TTsFlplan item : tTsFlplanMapper.selectTTsFlplanListByNewId(entity)) {
                    item.setPlanStatus(3L);
                    tTsFlplanMapper.updateTTsFlplan(item);
                }
            } else if (tsNew.getPlanType() == 4) {
                TTsFtplan entity = new TTsFtplan();
                entity.setNewId(tTsNew.getNewId());
                for (TTsFtplan item : tTsFtplanMapper.selectTTsFtplanListByNewId(entity)) {
                    item.setPlanStatus(3L);
                    tTsFtplanMapper.updateTTsFtplan(item);
                }
            }
            tTsNewMapper.updateTTsNew(tTsNew);
        }
        if (tTsNew.getPlanStatus() == 4) {
            TTsFirstplan tTsFirstplan = new TTsFirstplan();
            tTsFirstplan.setNewId(tTsNew.getNewId());
            for (TTsFirstplan tsFirstplan : tTsFirstplanMapper.selectTTsFirstplanListByNewId(tTsFirstplan)) {
                if (tsFirstplan.getPlanStatus() == null || tsFirstplan.getPlanStatus() == 0) {
                    tsFirstplan.setPlanStatus(4L);
                    tTsFirstplanMapper.updateTTsFirstplan(tsFirstplan);
                }
            }
            if (tsNew.getPlanType() == 1) {
                TTsLjplan entity = new TTsLjplan();
                entity.setNewId(tTsNew.getNewId());
                for (TTsLjplan item : tTsLjplanMapper.selectTTsLjplanListByNewId(entity)) {
                    if (item.getPlanStatus() == null || item.getPlanStatus() == 0) {
                        item.setPlanStatus(4L);
                        tTsLjplanMapper.updateTTsLjplan(item);
                    }
                }
            } else if (tsNew.getPlanType() == 2) {
                TTsYsplan entity = new TTsYsplan();
                entity.setNewId(tTsNew.getNewId());
                for (TTsYsplan item : tTsYsplanMapper.selectTTsYsplanListByNewId(entity)) {
                    if (item.getPlanStatus() == null || item.getPlanStatus() == 0) {
                        item.setPlanStatus(4L);
                        tTsYsplanMapper.updateTTsYsplan(item);
                    }
                }
            } else if (tsNew.getPlanType() == 3) {
                TTsFlplan entity = new TTsFlplan();
                entity.setNewId(tTsNew.getNewId());
                for (TTsFlplan item : tTsFlplanMapper.selectTTsFlplanListByNewId(entity)) {
                    if (item.getPlanStatus() == null || item.getPlanStatus() == 0) {
                        item.setPlanStatus(4L);
                        tTsFlplanMapper.updateTTsFlplan(item);
                    }
                }
            } else if (tsNew.getPlanType() == 4) {
                TTsFtplan entity = new TTsFtplan();
                entity.setNewId(tTsNew.getNewId());
                for (TTsFtplan item : tTsFtplanMapper.selectTTsFtplanListByNewId(entity)) {
                    if (item.getPlanStatus() == null || item.getPlanStatus() == 0) {
                        item.setPlanStatus(4L);
                        tTsFtplanMapper.updateTTsFtplan(item);
                    }
                }
            }
            tTsNewMapper.updateTTsNew(tTsNew);
            tsApproveService.doApprove(tTsNew.getNewId(), tsNew.getPlanType().toString(), userId, nickName);
        }
        if (tTsNew.getPlanStatus() == 5) {
            TTsFirstplan plan = new TTsFirstplan();
            plan.setNewId(tTsNew.getNewId());
            List<TTsFirstplan> tTsFirstplans = tTsFirstplanMapper.selectTTsFirstplanListByNewId(plan);
            plan.setPlanStatus(5L);
            List<TTsFirstplan> tTsFirstplansDone = tTsFirstplanMapper.selectTTsFirstplanListByNewId(plan);
            boolean flag = false;
            if (1 == tsNew.getPlanType()) {
                TTsLjplan tTsLjplan = new TTsLjplan();
                tTsLjplan.setNewId(tTsNew.getNewId());
                List<TTsLjplan> tTsLjplans = tTsLjplanMapper.selectTTsLjplanListByNewId(tTsLjplan);
                tTsLjplan.setPlanStatus(5L);
                List<TTsLjplan> tTsLjplansDone = tTsLjplanMapper.selectTTsLjplanListByNewId(tTsLjplan);
                if (!CollectionUtils.isEmpty(tTsLjplans)
                        && !CollectionUtils.isEmpty(tTsLjplansDone)
                        && tTsLjplansDone.size() == tTsLjplans.size()) {
                    flag = true;
                }
            } else if (2 == tsNew.getPlanType()) {
                TTsYsplan tTsYsplan = new TTsYsplan();
                tTsYsplan.setNewId(tTsNew.getNewId());
                List<TTsYsplan> tTsYsplans = tTsYsplanMapper.selectTTsYsplanListByNewId(tTsYsplan);
                tTsYsplan.setPlanStatus(5L);
                List<TTsYsplan> tTsYsplansDone = tTsYsplanMapper.selectTTsYsplanListByNewId(tTsYsplan);
                if (!CollectionUtils.isEmpty(tTsYsplans)
                        && !CollectionUtils.isEmpty(tTsYsplansDone)
                        && tTsYsplansDone.size() == tTsYsplans.size()) {
                    flag = true;
                }
            } else if (3 == tsNew.getPlanType()) {
                TTsFlplan tTsFlplan = new TTsFlplan();
                tTsFlplan.setNewId(tTsNew.getNewId());
                List<TTsFlplan> tTsFlplans = tTsFlplanMapper.selectTTsFlplanListByNewId(tTsFlplan);
                tTsFlplan.setPlanStatus(5L);
                List<TTsFlplan> tTsFlplansDone = tTsFlplanMapper.selectTTsFlplanListByNewId(tTsFlplan);
                if (!CollectionUtils.isEmpty(tTsFlplans)
                        && !CollectionUtils.isEmpty(tTsFlplansDone)
                        && tTsFlplansDone.size() == tTsFlplans.size()) {
                    flag = true;
                }
            } else if (4 == tsNew.getPlanType()) {
                TTsFtplan tTsFtplan = new TTsFtplan();
                tTsFtplan.setNewId(tTsNew.getNewId());
                List<TTsFtplan> tTsFtplans = tTsFtplanMapper.selectTTsFtplanListByNewId(tTsFtplan);
                tTsFtplan.setPlanStatus(5L);
                List<TTsFtplan> tTsFtplansDone = tTsFtplanMapper.selectTTsFtplanListByNewId(tTsFtplan);
                if (!CollectionUtils.isEmpty(tTsFtplans)
                        && !CollectionUtils.isEmpty(tTsFtplansDone)
                        && tTsFtplansDone.size() == tTsFtplans.size()) {
                    flag = true;
                }
            }
            if (!CollectionUtils.isEmpty(tTsFirstplans) &&
                    !CollectionUtils.isEmpty(tTsFirstplansDone) &&
                    tTsFirstplans.size() == tTsFirstplansDone.size() && flag) {
                tTsNewMapper.updateTTsNew(tTsNew);
                tsApproveService.doApprove(tTsNew.getNewId(), tsNew.getPlanType().toString(), userId, nickName);
            }
        }
        return 1;
    }

    /**
     * 批量删除导师带徒
     *
     * @param newIds 需要删除的导师带徒ID
     * @return 结果
     */
    @Override
    public int deleteTTsNewByIds(Long[] newIds) {
        return tTsNewMapper.deleteTTsNewByIds(newIds);
    }

    /**
     * 删除导师带徒信息
     *
     * @param newId 导师带徒ID
     * @return 结果
     */
    @Override
    public int deleteTTsNewById(Long newId) {
        return tTsNewMapper.deleteTTsNewById(newId);
    }
}
